<?php
/* ***
// Filepocket > fp_Form version 0.5.10E (August 10, 05)
// PHP web form creation and validation class
// By Edward Hew <edward@filepocket.org>
// http://www.filepocket.org/rack/fp_Form/
// LGPL Licence
//
// fp_Form have been adapted and renamed in ec_form by Heirem for Events Calendar (December 2008)
*** */

class ec_form
{
  var $required_array = array(),
      $f_validate = false,
      $validate_check = -1,
	    $group = array(),
      $tabindex_mem = array(),
      $file_types = array(),
	    $validate_alert_bgcolor = '#FCFFBC',
      $validate_pass_bgcolor = '#ffffff',
	    $as = '<span class="failed">',
      $ae = '</span>',
      $current_tab='',
      $current_subtab='',
      $echoJSHeader = false;

	function ec_form( $imgpath = '', $show_req_line = 'bottom', $show_label = true )
	{
	  $this->blank_img = $imgpath.'/blank.gif';
		$this->info_img = $imgpath.'/ecf_info.gif';
		$this->req_ico = $imgpath.'/ecf_req.gif';
		$this->warn_ico = $imgpath.'/ecf_warn.gif';
		$this->alrt_ico = $imgpath.'/ecf_alrt.gif';
		$this->show_req_line = $show_req_line;
		$this->show_label = $show_label;
		if (!function_exists('_c')) {
      function _c($a , $b) {
        return $a;
      }
    }
    /*
     * Declare messages used in ec_form
     */
    $this->messages_ec_form = array (
      'required_line' 	   => '<span class="req">%s</span>'._c('Symbol marks required fields','events-calendar'),
      'required_symbol' 	 => '<img title="'._c('This field will be checked for validation','events-calendar').'" src="'.$this->req_ico.'"/>',
      'js_msg_start' 		   => _c('Alert! Some fields require your attention!','events-calendar'),
      'js_msg_end' 		     => _c('Please check highlighted field(s)','events-calendar'),
      'nonempty' 			     => _c('Cannot be empty','events-calendar'),
      'posintorblank'      => _c(' Positive integer or blank field expected','events-calendar'),
      'positive_number' 	 => _c(' Positive number expected','events-calendar'),
      'negpos_numbers' 	   => _c(' Numbers only','events-calendar'),
      'checkbox_line1' 	   => _c(' Please select at least %d','events-calendar'),
      'checkbox_line2' 	   => _c(', but no more than %d choices','events-calendar'),
      'multiple_line1' 	   => _c(' Please select at least %d','events-calendar'),
      'multiple_line2' 	   => _c(', but no more than %d (Hold down Ctrl or Cmd to select multiple)','events-calendar'),
      'textarea' 			     => _c('Character limit exceeded. Current count: %d, Limit: %d','events-calendar'),
      'email' 			       => _c(' Email format not valid','events-calendar'),
      'emailorblank' 		   => _c(' Email format not valid','events-calendar'),
//      'isphone'      		   => _c(' Phone format not valid','events-calendar'),
      'username' 			     => _c(' Must be between 5-16 alphanumeric or the _ character only','events-calendar'),
      'characters_counter' => _c(' Character Limit %d','events-calendar'),
      'character_counter2' => _c(' Current count:','events-calendar'),
      'field' 			       => _c('field','events-calendar'),
      'counter_noscript' 	 => _c('Note: The character counter feature requires JavaScript to function.','events-calendar'),
      // 'noscript_general' 	=> _c('(NOTE: You have JavaScript disabled, some features of this form will not work.)<br />','events-calendar'),
      'UPLOAD_1' 		 => _c('File exceeds the maximum file size allowed set by the server. [Err No.1].','events-calendar'),
      'UPLOAD_2'		 => _c('File exceeds the maximum file size allowed set on this page. [Err No.2].','events-calendar'),
      'UPLOAD_3'		 => _c('File was only partially uploaded. [Err No.3].','events-calendar'),
      'UPLOAD_4'		 => _c('File was not uploaded.','events-calendar'),
      'UPLOAD_6'		 => _c('System configuration error, missing a temporary folder. Please contact site owner. [Err No.6]','events-calendar'),
      'resetconfirm' => _c('Are you sure you want to reset this form?','events-calendar')
    );
    /*
     * Declare Regular Expression patterns
     */
    $this->regex_patterns = array (
      'username' => '/^[^\W]{5,16}$/', //> Alphanumeric '_' between 5 and 16 chars
      'email' => '/(\w[-._\w]*\w@\w[-._\w]*\w\.\w{2,3})/', //> regexlib.com Darren Neimke
      'emailorblank' => '/(\w[-._\w]*\w@\w[-._\w]*\w\.\w{2,3})|(^\s*$)/', //> Email or blank
      'posintorblank' => '/(^\d+$)|(^\s*$)/',
      'positive_number' => '/([0-9]*\.)?[0-9]+([eE][-+]?[0-9]+)?/', //> modified from http://www.regular-expressions.info/floatingpoint.html
      'negpos_numbers' => '/[-+]?([0-9]*\.)?[0-9]+([eE][-+]?[0-9]+)?/', //> Negative or positive, integer or floating point thanks to: http://www.regular-expressions.info/floatingpoint.html
      'nonempty' => '/\S/' //> Any character but no tab, white space or new line character, not blank.
    );
	}

	function ecform_start($action='',$nameid='',$method='post',$validate=false,$etc=''){ // PUBLIC
		static $counter=0; $validate_eh='';
		if(!$nameid) $nameid = 'form'.++$counter;
		$this->js_validate_name = 'validate_'.$nameid.'()';
		$this->f_method = $method;
		if($method === 'post' ) {
			$this->g_submit =& $_POST;
			$this->submission_counted = count($_POST);
		}	else {
			$this->g_submit =& $_GET;
			$this->submission_counted = count($_GET);
		}
		if($validate) {
			$validate_eh = ' onsubmit="return '.$this->js_validate_name.'"';
			$this->f_validate = true;
		}
		$this->form_name = $nameid;
    $this->f_start = '<form id="'.$nameid.'" name="'.$nameid.'" action="'.$action.'" method="'.$method.'" '.$etc.$validate_eh.'>'."\n\t";
		$this->f_start .= '<input type="hidden" name="'.$nameid.'_submitted" value="true"/>'."\n";
		if($validate && $this->show_req_line === 'top')
			$this->f_start .= '<div class="req_line">'.sprintf($this->messages_ec_form['required_line'],$this->messages_ec_form['required_symbol']).'</div>';
		return $this->f_start;
	}

	function curtab($ct){ // PUBLIC
		$this->current_tab = $ct;
	}

	function cursubtab($cst){ // PUBLIC
		$this->current_subtab = $cst;
	}

	function tabindex($num)	{
		if(is_numeric($num)) $this->tabindex = $num; else	$this->tabindex = false;
	}

	function accesskey($key)	{
		if(is_string($key))	$this->accesskey = $key; else	$this->accesskey = false;
	}

	function fieldset($action, $legend='&nbsp;',$etc_fieldset='',$etc_legend='', $helper ='') { // PUBLIC
		$output = '';
		if($action == 'start') {
		  if($legend == '&nbsp;') $nodisplay = ' style="display:none;"';
			$output = '<fieldset '.$etc_fieldset.'>';
			if ($legend != '' && $legend != '&nbsp;') {
        $output .= '<legend '.$etc_legend.$nodisplay.'>'.$legend.(($helper!='')?'&nbsp;<img class="ecf-info_img" tooltipText="'.$helper.'" src="'.$this->info_img.'" border="0"/>':'')."</legend>\n"; 
      }else $output .="\n";
			$pos = 'fieldset_start';
		}
		else if($action == 'end')	{
			$output = "\n</fieldset>";
			$pos = 'fieldset_end';
		}	else {
			echo '<strong>Warning!</strong> fieldset object action only accepts "start" and "end" as first parameter<br />
			eg: fieldset("start","Fieldset Legend","class="section1")';
		}
		$this->fields[] = array('name'=>'','label'=>'','right'=>'','required'=>'','alert'=>'','helper'=>'','post_text'=>'','fieldset_pos'=>$pos,'fieldset'=>$output);
	}

	function do_label($name,$imgsrc,$label,$element_type,$required='',$left_extra='') {
		$dlabel_extra = ''; $dlabel = ''; $classlabel = ' class="fieldLabel"';
    if($element_type == 'checkbox') $this->check_range_error($name,$element_type,$required);
    if($element_type == 'radio' || $element_type == 'checkbox') $classlabel = ' class="grpFieldLabel"'; 
		if($label && $this->show_label) {
  			if( is_array($label)) {
  				$dlabel = $label[0];
  				$dlabel_extra = $label[1];
  			}	else $dlabel = $label;
  			if($required && $this->f_validate)	{
        	$show_ast = '<span class="req">'.$this->messages_ec_form['required_symbol'].'</span>';
  				$s_start = '<strong>'; $s_end = '</strong>';
  			}	else {
  				$show_ast = ''; $s_start = '';
  				if($dlabel !== '&nbsp;') $s_end = ':'; else $s_end = '';
  			}
			if($label == '&nbsp;' || $imgsrc || !$dlabel)
				$label_check = ' style="display:none;"';
			else $label_check = ' for="'.$name.'"'.$classlabel;
			if($imgsrc)
			 return ('<img src="'.$imgsrc.'" title="'.$label.'" id="'.strtolower($name).'_imglabel"/>'."\n");
			else return ('<label'.$label_check.'>'.$s_start.$dlabel.$s_end.$show_ast.$dlabel_extra.$left_extra.' </label>'."\n");
		} else return '';
	}

	function do_columns($name, $initially_checked, $list_array, $columns, $id_name, $type) {
		$output = '';
		$clean_name = str_replace('[]','',$name);// strip []
		$num_items = count($list_array);
		$each_col = ceil($num_items / $columns);
		$pointer = $each_col;
		$output .= "\n".'<table class="form_columns" summary="" id="'.$id_name.'">'."\n <tr>\n";
		$i = 0; $j = 1; $starter = true; $end = true;
		while (list($key, $val) = each($list_array)) {
			if($columns >= $j) {
				if($starter) $output .= "\t<td>";
				if($pointer >= ++$i) {
					if(is_array($val)) {$etc = @$val[1]; $val = $val[0];
					}	else {$val = $val; $etc = '';}
					if($type == 'radio') {
						if($initially_checked == $val) $checked = ' checked="checked"'; else $checked = '';
							$output .= '<input type="radio" name="'.$name.'" id="'.$clean_name.'_'.$key.'" value="'.$val.'"'.$checked.' '.$this->tabindex_process().' '.$etc.' class="radio"/><label class="grpColFieldSubLabel" for="'.$clean_name.'_'.$key.'">'.$val."</label><br />\n\t";
					}	else if($type=='checkbox') {
						if(@in_array($key,$initially_checked))
							$checked = ' checked="checked"'; else $checked = '';
						$output .= '<input type="checkbox" name="'.$name.'[]" id="'.$clean_name.'_'.$key.'" value="'.$key.'"'.$checked.' '.$this->tabindex_process().' '.$etc.' class="checkbox"/><label class="grpColFieldSubLabel" for="'.$clean_name.'_'.$key.'">'.$val."</label><br />\n\t";
					}
					$starter = false;
					$end = false;
				}
				if($pointer == $i) {
					++$j;
					$output .= "</td>\n";
					$starter = true;
					$end = true;
					$pointer = $each_col * $j;
				}
			}
		}
		if($end == false)	$output .= '</td>';
		$output .= "\n </tr>\n</table>\n";
		return $output;
	}

	function wrong_type($type,$name) {
		echo '<strong style="color:red">**Alert**</strong> Wrong field type "'.$type.'" for field name <strong>'.$name.'</strong>';
	}

	function tabindex_process($nostr=false) {
		if($this->tabindex !== false)	{
			if(in_array($this->tabindex,$this->tabindex_mem))
				echo '<strong>Warning!</strong> tabindex '.$this->tabindex.' already used on this form!';
			else {
				$this->tabindex_mem[] = $this->tabindex;
				$tabindex_relay = ' tabindex="'.($this->tabindex).'"';
				++$this->tabindex;
			}
		}	else {
			$this->tabindex = false;
			$tabindex_relay = '';
		}
		if(!$nostr) return $tabindex_relay; else return $this->tabindex;
	}

	function accesskey_process($label) {
		$accesskey_relay = '';
		if($this->accesskey !== false) { 	// underline access key character
			// Clear the first TAG
			$pattern = '/(>[^<]*)('.$this->accesskey.')([^<>]*)/i';
			if(is_array($label)) {
				// Grab the general area, if no match skip
				preg_match($pattern, $label[1], $matches , PREG_OFFSET_CAPTURE, 6);
				$str1 = preg_replace('/'.$this->accesskey.'/','<u title="Alt/Cmd key + &#39;'.$this->accesskey.'&#39;">'.$this->accesskey.'</u>', $matches[0][0], 1);
				$label[1] = str_replace($matches[0][0],$str1,$label[1]);
				$accesskey_relay = ' accesskey="'.$this->accesskey.'"';
				$this->accesskey = false;
			}	else {
				$pattern = '/'.$this->accesskey.'/i';
				$label = preg_replace($pattern, '<span class="u" title="Alt/Cmd key + &#39;'.$this->accesskey.'&#39;">'.$this->accesskey.'</span>', $label,1);
				$accesskey_relay = ' accesskey="'.$this->accesskey.'"';
				$this->accesskey = false; // reset variable
			}
		}
		return (array('label'=>$label,'accesskey_line'=>$accesskey_relay));
	}

	function text_field($type,$imgsrc,$label,$name,$value='',$required='',$size='20',$maxlength='',$helper='',$etc='',$post_text='', $ect_cssdivrow='', $ect_cssdivcell='') {
		$set_alertdiv = ''; $s = ''; $e = '';
		if($type != 'text' && $type != 'password' && $type != 'textimglabel')	$this->wrong_type($type,$name);
		if($required || $this->submission_counted > 0) {
			$check_submitted = $this->check_submission($name,$value,'text',$required);
			$this->required_fields[] = $name;
			if(count($check_submitted) > 0)	$value = @$check_submitted[$name]['value'];
			if(@$check_submitted[$name]['err_msg'] != '')	{
				$s = $this->as;
				$e = $this->ae;
			}
		}
		$accesskey_check = $this->accesskey_process($label);
		$left = $this->do_label($name,$imgsrc,$accesskey_check['label'],$type,$required);
    $type = ($type == 'textimglabel') ? 'text' : $type;
		$right = $s.'<input type="'.$type.'" name="'.$name.'" id="'.$name.'" value="'.$value.'" size="'.$size.'" maxlength="'.$maxlength.'" '.$etc.$accesskey_check['accesskey_line'].$this->tabindex_process().' />'.$e;
		$this->jsvalidate[$name] = array('label'=>$label,'type'=>'text','validate'=>$required,'subgroup'=>$this->subgroup,'curtab'=>$this->current_tab,'cursubtab'=>$this->current_subtab);
		$this->fields[] = array('name'=>$name,'label'=>$left,'right'=>$right,'required'=>$required,'alert'=>@$check_submitted[$name]['err_msg'],'helper'=>$helper,'post_text'=>$post_text,'fieldset_pos'=>'','fieldset'=>'','ect_cssdivrow'=>$ect_cssdivrow,'ect_cssdivcell'=>$ect_cssdivcell);
	}

	function text($label,$name,$value='',$required='',$size='20',$maxlength='',$helper='',$etc='',$post_text='',$ect_cssdivrow='', $ect_cssdivcell='') { // PUBLIC
		$this->text_field('text','',$label,$name,$value,$required,$size,$maxlength,$helper,$etc,$post_text,$ect_cssdivrow,$ect_cssdivcell);
	}

	function text_imglabel($imgsrc,$label,$name,$value='',$required='',$size='20',$maxlength='',$helper='',$etc='',$post_text='',$ect_cssdivrow='', $ect_cssdivcell='') { // PUBLIC
		$this->text_field('textimglabel',$imgsrc,$label,$name,$value,$required,$size,$maxlength,$helper,$etc,$post_text,$ect_cssdivrow,$ect_cssdivcell);
	}

	function password($label,$name,$value='',$required='',$size='20',$maxlength='',$helper='',$etc='',$post_text='',$ect_cssdivrow='', $ect_cssdivcell='') { // PUBLIC
		$this->text_field('password','',$label,$name,$value,$required,$size,$maxlength,$helper,$etc,$post_text,$ect_cssdivrow,$ect_cssdivcell);
	}

	function hidden($name, $value='', $etc='') { // PUBLIC
		$check_submitted = $this->check_submission($name,$value,'hidden','');
		if(count($check_submitted) > 0) $value = $check_submitted[$name]['value'];
		$this->fields[] = array('name'=>$name,'label'=>'','right'=>'<input type="hidden" name="'.$name.'" id="'.$name.'" value="'.$value.'" '.$etc.' />'."\n",'required'=>'','alert'=>'','helper'=>'','post_text'=>'','fieldset_pos'=>'','fieldset'=>'');
	}

	function textarea($label, $name, $value='' ,$required='' ,$cols='30' ,$rows='3' ,$helper='' ,$etc='', $post_text = '',$ect_cssdivrow='', $ect_cssdivcell='') { // PUBLIC
		$left_extra = ''; $char_counter = false; $s = ''; $e = '';
		if($required !== '' || $this->submission_counted > 0)	{
			$check_submitted = $this->check_submission($name,$value,'textarea',$required);
			$this->required_fields[] = $name;
			if(count($check_submitted) > 0) $value = @$check_submitted[$name]['value'];
			if( @$check_submitted[$name]['err_msg'] !== '') {
				$s = $this->as;
				$e = $this->ae;
			}
		}
		if( is_numeric($required)) {
			$etc .= " onkeyup=\"countChars(this,'".$required."','".$this->form_name."','counter_".$name."','".$label."')\"";
			$left_extra = '<br /><span class="sublabel">'.sprintf($this->messages_ec_form['characters_counter'],$required).'<script type="text/javascript"><!--'."\n\t".'document.write("<div>'.$this->messages_ec_form['character_counter2']." <strong><span id='counter_".$name."'> </span></strong></div>".'");'."\n\t //--></script></span>";
			$this->show_counters .= 'countChars(document.getElementById("'.$this->form_name.'").'.$name.','.$required.',"'.$this->form_name.'","counter_'.$name.'","'.$label.'");';
			$char_counter = true;
		}
		$accesskey_check = $this->accesskey_process($label);
		$left = $this->do_label($name,'',$accesskey_check['label'],'textarea',$required,$left_extra);
		$right = $s.'<textarea name="'.$name.'" id="'.$name.'" cols="'.$cols.'" rows="'.$rows.'" '.$etc.$accesskey_check['accesskey_line'].$this->tabindex_process().'>'.$value.'</textarea>'.$e;
		$this->jsvalidate[$name] = array('label'=>$label,'type'=>'textarea','validate'=>$required,'subgroup'=>$this->subgroup,'curtab'=>$this->current_tab,'cursubtab'=>$this->current_subtab);
		$this->fields[] = array('name'=>$name,'label'=>$left,'right'=>$right,'required'=>$required,'alert'=>@$check_submitted[$name]['err_msg'],'helper'=>$helper,'post_text'=>$post_text,'fieldset_pos'=>'','fieldset'=>'','ect_cssdivrow'=>$ect_cssdivrow,'ect_cssdivcell'=>$ect_cssdivcell);
	}

	function select($label, $name, $initially_selected, $list_values, $required='', $helper='', $etc='', $post_text='', $mode='single', $rows=12, $ect_cssdivrow='', $ect_cssdivcell='') { // PUBLIC
		$name_checked=''; $s = ''; $e = '';
		if($required !== '' || $this->submission_counted > 0)	{
			$check_submitted = $this->check_submission($name,$initially_selected,$mode,$required);
			$this->required_fields[] = $name;
			if( count($check_submitted) > 0)	$initially_selected = @$check_submitted[$name]['value'];
			if(@$check_submitted[$name]['err_msg'] != '')	{
				$s = $this->as;
				$e = $this->ae;
			}
		}
		$multiple = ''; $size = '';
		if($mode === 'multiple') {
			$name_checked = $name.'[]';
			$multiple = ' multiple="multiple"';
			$size = ' size="'.$rows.'"';
		} else {
			$mode = 'select';
			$name_checked = $name;
		}
		$left = $this->do_label($name,'',$label,$mode,$required);
		$right = $s.'<select name="'.$name_checked.'" id="'.$name.'" '.$etc.$multiple.$size.' '.$this->tabindex_process().'>'."\n";
		$odd = true;
		foreach($list_values as $key=>$val) {
			if (@in_array($key, $initially_selected))	$selected = ' selected="selected"';
			else if ($key == $initially_selected) $selected = ' selected="selected"';
			else $selected = '';
			$odd = !$odd;
			$right .= "\t\t\t".'<option value="'.$key.'"'.$selected.($odd?' class="optOdd" ':'').'>'.$val.'</option>'."\n";
		}
		$right .= "\t\t".'</select>'.$e;
		if(is_array($label)) $label = $label[0];
		$this->jsvalidate[$name] = array( 'label'=>$label, 'type'=>$mode, 'validate'=>$required, 'subgroup'=>$this->subgroup,'curtab'=>$this->current_tab,'cursubtab'=>$this->current_subtab);
		$this->fields[] = array( 'name'=>$name_checked, 'label'=>$left, 'right'=>$right, 'required'=>$required, 'alert'=>@$check_submitted[$name]['err_msg'], 'helper'=>$helper, 'post_text'=>$post_text, 'fieldset_pos'=>'', 'fieldset'=>'','ect_cssdivrow'=>$ect_cssdivrow,'ect_cssdivcell'=>$ect_cssdivcell);
	}

	function radio($label, $group_name, $initially_checked, $radio_list_array, $required='', $position='horizontal', $helper='', $post_text='', $columns = '', $ect_cssdivrow='', $ect_cssdivcell='') { // PUBLIC
		$lbreak = ''; $right = '';
		if($position=='vertical') $lbreak = '<br />';
		if($required !== '' || $this->submission_counted > 0)	{
			$check_submitted = $this->check_submission($group_name,$initially_checked,'radio',$required);
			$this->required_fields[] = $group_name;
			if( count($check_submitted) > 0)	{
				if(empty($check_submitted[$group_name]['value'])) {
					$check_submitted[$group_name]['err_msg'] = $this->messages_ec_form[$required];
					$initially_checked = '';
				}	else	$initially_checked = @$check_submitted[$group_name]['value'];
			}
		}
		$accesskey_check = $this->accesskey_process($label);
		$left = $this->do_label($group_name,'',$accesskey_check['label'],'radio',$required);

		if($columns == '') {
		  $right = '<div class="GroupField" id="'.$group_name.'_span">'."\n";
		  foreach($radio_list_array as $val => $name) {
  			if($initially_checked == $val) $checked = ' checked="checked"';
  			else $checked = '';
  			if(is_array($name))	{
  				$etc = @$name[1];
  				$name = $name[0];
  			}	else {
  				$name = $name;
  				$etc = '';
  			}
  			$right .= "\t\t\t\t".'<input type="radio" name="'.$group_name.'" id="'.$val.'" value="'.$val.'"'.$checked.' '.$accesskey_check['accesskey_line'].
  			$this->tabindex_process().' '.$etc.' class="radio"/><label class="grpFieldSubLabel" for="'.$val.'">'.$name.'</label>';
  			$right .= next($radio_list_array) ? $lbreak."\n":"\n";
		  }
		  $right .= "\t\t\t".'</div>';
		}	else {
			if(!is_numeric($columns))	echo 'Warning! Interger expected for field name '.$group_name;
			$right .= $this->do_columns($group_name,$initially_checked,$radio_list_array,$columns,$group_name.'_span','radio');
		}
		$this->jsvalidate[$group_name] = array('label'=>$label,'type'=>'radio','validate'=>$required,'subgroup'=>$this->subgroup,'curtab'=>$this->current_tab,'cursubtab'=>$this->current_subtab);
		if(!is_array($radio_list_array)) echo $label.' Parameter 4 array expected.<br />';
		else $this->fields[] = array('name'=>$group_name,'label'=>$left,'right'=>$right,'required'=>$required,'alert'=>@$check_submitted[$group_name]['err_msg'],'helper'=>$helper,'post_text'=>$post_text,'fieldset_pos'=>'','fieldset'=>'','ect_cssdivrow'=>$ect_cssdivrow,'ect_cssdivcell'=>$ect_cssdivcell);
	}

  function custom_code($label, $name, $code, $helper='', $etc='', $post_text='', $ect_cssdivrow='', $ect_cssdivcell='') { // PUBLIC
 		$right = '';
		$accesskey_check = $this->accesskey_process($label);
    $left = $this->do_label($name,'',$accesskey_check['label'],'custom');
		if($code == '') {	echo $label,' :Warning! Custom code is expected '; return;}
    $right = $code;
		$this->jsvalidate[$name] = array('label'=>$label,'type'=>'custom','validate'=>'','subgroup'=>$this->subgroup,'curtab'=>$this->current_tab,'cursubtab'=>$this->current_subtab);
  	$this->fields[] = array('name'=>$name,'label'=>$left,'right'=>$right,'required'=>'','alert'=>@$check_submitted[$name]['err_msg'],'helper'=>$helper,'post_text'=>$post_text,'fieldset_pos'=>'','fieldset'=>'','ect_cssdivrow'=>$ect_cssdivrow,'ect_cssdivcell'=>$ect_cssdivcell);
  }

	function checkbox_trigger($label, $name, $value, $checked=false, $helper='', $etc='', $post_text='', $ect_cssdivrow='', $ect_cssdivcell='') { // PUBLIC
		$right = '';
		$accesskey_check = $this->accesskey_process($label);
		$left = $this->do_label($name,'',$accesskey_check['label'],'checkbox_trigger');
		if($checked == true) $checked = ' checked="checked"';	else $checked = '';
		$right = "\n\t".'<input type="checkbox" name="'.$name.'" id="'.$name.'" value="'.$value.'"'.$checked.' '.$accesskey_check['accesskey_line'].$this->tabindex_process().' '.$etc.' class="checkbox"/>';
		$this->jsvalidate[$name] = array('label'=>$label,'type'=>'checkbox_trigger','validate'=>'','subgroup'=>$this->subgroup,'curtab'=>$this->current_tab,'cursubtab'=>$this->current_subtab);
  	$this->fields[] = array('name'=>$name,'label'=>$left,'right'=>$right,'required'=>'','alert'=>@$check_submitted[$name]['err_msg'],'helper'=>$helper,'post_text'=>$post_text,'fieldset_pos'=>'','fieldset'=>'','ect_cssdivrow'=>$ect_cssdivrow,'ect_cssdivcell'=>$ect_cssdivcell);
	}

	function checkbox($label, $group_name, $initially_checked_array, $checkbox_list_array, $required='', $position='horizontal', $helper='', $post_text='', $columns = '', $ect_cssdivrow='', $ect_cssdivcell='') { // PUBLIC
		$lbreak = ''; $right = '';
		if($position=='vertical') $lbreak = '<br />';
		if($required !== '' || $this->submission_counted > 0) {
			$counted_array = count($checkbox_list_array);
			$check_submitted = $this->check_submission($group_name,$initially_checked_array,'checkbox',$required,$counted_array);
			$this->required_fields[] = $group_name;
			if(count($check_submitted) > 0) $initially_checked_array = @$check_submitted[$group_name]['value'];
		}
		$accesskey_check = $this->accesskey_process($label);
		$left = $this->do_label($group_name,'',$accesskey_check['label'],'checkbox',$required);
		if($initially_checked_array=='') $initially_checked_array = array();
		if($columns == '') {
		    $right = '<div class="grouper" id="'.$group_name.'_span">'."\n";
		    foreach($checkbox_list_array as $val => $name) {
    			if(in_array($val,$initially_checked_array))	$checked = ' checked="checked"';
    			else $checked = '';
    			if(is_array($name))	{$etc = @$name[1]; $name = $name[0];
    			}	else {$name = $name;$etc = '';}
    			$right .= "\t\t\t\t".'<input type="checkbox" name="'.$group_name.'[]" id="'.$val.'" value="'.$val.'"'.$checked.' '.$accesskey_check['accesskey_line'].$this->tabindex_process().' '.$etc.' class="checkbox"/><label class="grpFieldSubLabel" for="'.$val.'">'.$name.'</label>';
    			$right .= next($checkbox_list_array) ? $lbreak."\n":"\n";
		    }
		    $right .= '</div>';
		}	else {
			if(!is_numeric($columns))	echo 'Warning! Interger expected for field name '.$group_name;
			$right .= $this->do_columns($group_name,$initially_checked_array,$checkbox_list_array,$columns,$group_name.'_span','checkbox');
		}
		$this->jsvalidate[$group_name] = array('label'=>$label,'type'=>'checkbox','validate'=>$required,'subgroup'=>$this->subgroup,'curtab'=>$this->current_tab,'cursubtab'=>$this->current_subtab);
		if( !is_array($checkbox_list_array))	echo $group_name.' Parameter 4 array expected.<br />';
		else $this->fields[] = array('name'=>$group_name,'label'=>$left,'right'=>$right,'required'=>$required,'alert'=>@$check_submitted[$group_name]['err_msg'],'helper'=>$helper,'post_text'=>$post_text,'fieldset_pos'=>'','fieldset'=>'','ect_cssdivrow'=>$ect_cssdivrow,'ect_cssdivcell'=>$ect_cssdivcell);
	}

	function button($type,$label,$name,$value_or_src,$etc='',$post_text='',$post_text_position='', $ect_cssdivrow='', $ect_cssdivcell='') {
		$submit = '';
		if($type!=='submit' && $type!=='button' && $type!=='reset' && $type!=='image')
			$type = 'submit';
    if($label) {
		  $accesskey_check = $this->accesskey_process($label);
		  $left = $this->do_label($name,'',$accesskey_check['label'],'button');
		}
		if($post_text_position=='horizontal')	{
			$submit .= '
<table summary="secondary action" class="form_button_table">
   <tr>
	<td>
';
		}
		if($type === 'image')
			$submit .='<input type="'.$type.'" name="'.$name.'" id="'.$name.'" alt="'.$name.'" src="'.$value_or_src.'" '.$etc.$accesskey_check['accesskey_line'].$this->tabindex_process().' />';
		else
		$submit .='<input type="'.$type.'" name="'.$name.'" id="'.$name.'" value="'.$value_or_src.'" '.$etc.$accesskey_check['accesskey_line'].$this->tabindex_process().' />';
		if($post_text_position=='horizontal')	{
			$submit .= '
	</td>
	<td>
	'.$post_text.'
	</td>
   </tr>
</table>';
			// Post text reset
			$post_text = '';
		}
		$this->fields[] = array('name'=>$name,'type'=>ucfirst($type),'label'=>$left,'required'=>'','right'=>$submit,'alert'=>false,'helper'=>false,'post_text'=>$post_text,'fieldset_pos'=>'','fieldset'=>'','ect_cssdivrow'=>$ect_cssdivrow,'ect_cssdivcell'=>$ect_cssdivcell);
	}

	function browse($label, $name, $required='', $MAX_FILE_SIZE=30000, $HTML_size = 20, $accept = '', $helper='', $etc='', $post_text='', $ect_cssdivrow='', $ect_cssdivcell='') {
		static $counter = 0; $right = ''; $s = ''; $e = '';
		if($this->upload_dir === '') // Print alert message if upload dir not set
			echo '<strong style="color:red"> Warning!</strong> Upload directory not defined. <br />$obj->set_upload_dir(upload_directory);';
		else if( !is_dir($this->upload_dir))
			echo '<strong style="color:red"> Warning!</strong> Upload directory does not exist - '.$this->upload_dir.'<br />Set it with $obj->set_upload_dir(upload_directory);';
		$this->file_types = explode(',',$accept);
		$this->multiplart = 'enctype="multipart/form-data"';
		if($required !== '' || $this->submission_counted > 0)	{
			$check_submitted = $this->check_submission($name,'','file',$required);
			$this->required_fields[] = $name;
			if(count($check_submitted) > 0) $value = @$check_submitted[$name]['value'];
			if( @$check_submitted[$name]['err_msg'] !== '')	{
				$s = $this->as;
				$e = $this->ae;
			}
		}

		$this->jsvalidate[$name] = array('label'=>$label,'type'=>'file','validate'=>$required,'subgroup'=>$this->subgroup,'curtab'=>$this->current_tab,'cursubtab'=>$this->current_subtab);
		$left = $this->do_label($name,'',$label,'button',$required);
		if($counter++ === 0) $right = '<input type="hidden" name="MAX_FILE_SIZE" value="'.$MAX_FILE_SIZE.'" />'."\n\t\t";
		$right .= $s.'<input type="file" size="'.$HTML_size.'" name="'.$name.'" id="'.$name.'" accept="'.$accept.'" '.$etc.$this->tabindex_process().' />'.$e;
		$this->fields[] = array('name'=>$name,'label'=>$left,'right'=>$right,'required'=>$required,'alert'=>@$check_submitted[$name]['err_msg'],'helper'=>$helper,'post_text'=>$post_text,'fieldset_pos'=>'','fieldset'=>'','ect_cssdivrow'=>$ect_cssdivrow,'ect_cssdivcell'=>$ect_cssdivcell);
	}

	function set_upload_dir($path) {
		$this->upload_dir = $path;
	}

	function ecform_end()	{
		$this->f_end .= "\n\n".'</form>'."\n";
		if($this->f_validate === true && $this->show_req_line === 'bottom')
			$this->f_end .= '<div class="req_line">'.sprintf($this->messages_ec_form['required_line'], $this->messages_ec_form['required_symbol']).'</div>';
		return $this->f_end;
	}

	function subgroup($toggle) { // PUBLIC
		static $nest_checks = 0;
		if($nest_checks > 1) {
			echo '<strong style="color:red">Oh!</strong> Cannot nest subgroups.';
		}
		if($toggle == 'start') {
			$this->subgroup = 'start';
			$this->fields[] = array('name'=>'','label'=>'','right'=>'startsubgroup','required'=>'','alert'=>'','helper'=>'','post_text'=>'','fieldset_pos'=>'','fieldset'=>'');
			++$nest_checks;
		}	else if($toggle == 'end')	{
			$this->subgroup = 'end';
			$this->fields[] = array('name'=>'','label'=>'','right'=>'endsubgroup','required'=>'','alert'=>'','helper'=>'','post_text'=>'','fieldset_pos'=>'','fieldset'=>'');
			$nest_checks = 0;
		}
		return $this->subgroup;
	}

	function group($toggle,$css='class="group"') { // PUBLIC
		static $nest_checks = 0; static $i = 0;
		if($nest_checks > 1) {
			echo '<strong style="color:red">**Alert**</strong> Cannot nest groups, sorry.';
		}
		if($toggle == 'start') {
			$this->group['toggle'] = 'start';
			$this->group[$i]['css'] = $css;
			$this->fields[] = array('name'=>'','label'=>'','right'=>'startgroup','alert'=>'','helper'=>'','post_text'=>'','fieldset_pos'=>'','fieldset'=>'');
			++$nest_checks; ++$i;
		}	else if($toggle == 'end')	{
			$this->group['toggle'] = 'end';
			$this->fields[] = array('name'=>'','label'=>'','right'=>'endgroup','alert'=>'','helper'=>'','post_text'=>'','fieldset_pos'=>'','fieldset'=>'');
			$nest_checks = 0;
		}
		return $this->group;
	}

	function display($section='') { // PUBLIC
	  static $static_pointer = 0; $pointer = 0;
		$halt_blocks = 0; $err_msg_span = ''; $f_helper = ''; $i = 0; $f_name = '';
		if($section == "" || $section == 'head') {
    	if($this->f_start === '')
   			echo '<strong style="color:red">ecform_start()</strong> not defined!! <br />$obj->ecform_start($action="", $name="", $method="post", $validate=false, $etc="")';
      else
  		  if($this->multiplart !== '') $this->f_start = str_replace('action=',$this->multiplart.' action=',$this->f_start);
  		$output = "\n\n".$this->f_start;
  		if($section == 'head') return $output;
  	}
		$counted = count($this->g_submit);
		if ($counted > 0)	$output .= '<div class="alert_header">';
		if($this->validate_check > -1)	$output .= $this->messages_ec_form['js_msg_start'];
		if ($counted > 0)	$output .= '</div>';
		foreach($this->fields as $key=>$val)	{
      $pointer++; // store the last use
      if($pointer <= $static_pointer) continue;
			if($val['right'] === 'startgroup')	{
				$output .= "\n\n\n".'<div '.$this->group[$i]['css'].'><!-- group START -->'; // start group
				++$i;
			}
			if( @$val['fieldset_pos'] === 'fieldset_start') $output .= $val['fieldset'];
			else if($val['label'] !== '' || $this->show_label === false) {
			  $addClass = $val['name']; if ($addClass) $addClass = ' fieldRow'.(($val['type'])?$val['type']:$this->jsvalidate[$addClass]['type']); 
				$output .= "\n".'<div '.@$val['ect_cssdivrow'].' class="fieldRow'.$addClass.'">'."\n\t".$val['label'];
			}
			if($halt_blocks === 'warmingup')	$halt_blocks = 'in_effect';
			if($halt_blocks === 'begin') $halt_blocks = 'warmingup';
			if($val['label'] === '' && $val['right'] == 'startsubgroup')	{
				$output .= "\n".'<!-- Start Sub-group -->';
				$halt_blocks = 'begin';
			}
			if($halt_blocks !== 'in_effect' && $val['label'] !== '' && $val['right'] != 'fieldset') {
			  $addClass = $val['name']; if ($addClass) $addClass = ' fieldCell'.$this->jsvalidate[$addClass]['type'];   
				$output .= "\t".'<div '.@$val['ect_cssdivcell'].' class="fieldCell'.$addClass.'">'."\n\t";
			}
			if($val['right'] !== 'startsubgroup' && $val['right'] !== 'endsubgroup' && $val['right'] !== 'startgroup' && $val['right'] !== 'endgroup') {
				$output .= $val['right'];
  		if($val['helper'] != '' && $halt_blocks === 'warmingup') $f_helper = $val['helper'];
			if($val['helper'] != '' && $halt_blocks !== 'warmingup') {
					$output .= "\n\t".'<img id="'.$val['name'].'_img" class="ecf-info_img" tooltipText="'.$val['helper'].'" src="'.$this->info_img.'" border="0" />';
					$f_helper .= $val['helper'];
			} else if($val['required'])
				    $output .= "\n\t".'<img id="'.$val['name'].'_img" src="'.$this->blank_img.'" tooltipText="" class="ecf-info_img" border="0" />';
        $f_name = $val['name'];
				$output .= $val['post_text'];
				if(@array_key_exists($val['name'], $this->external_crosscheck_msg))
					$val['alert'] = $this->external_crosscheck_msg[$val['name']]['errmsg'];
			}
			if (@$val['fieldset_pos'] === 'fieldset_end')
				$output .= $val['fieldset'];
			else {
			    if($val['right'] === 'endsubgroup' && $halt_blocks === 'in_effect') {
            $halt_blocks = 0; // subgroup end
      			if($val['alert'] !== false)
					  $output .= $err_msg_span."\n\t</div>\n</div>";
				    // Reset variables
				    $f_name = '';
				    $f_helper = '';
				    $err_msg_span = '';
					  $output .= "\n".'<!-- End Sub-grounp -->';
			    } else if($val['label'] !== '' && $halt_blocks !== 'in_effect' && $halt_blocks !== 'warmingup') {
      				if($val['alert'] !== false)	$output .= $err_msg_span;
      				$output .= "\n\t</div>\n</div>\n\n";
      				$err_msg_span = '';
			    }
			    if($this->show_label === false)
			    	$output .= "\n</div>\n\n"; // End fieldRow block if show_label is false
			    if($val['right'] === 'endgroup') $output .= "</div><!-- group END -->\n"; // end group
			}
		}
		$static_pointer = $pointer;
		if($section !== "body" || $section == 'foot') $output .= $this->ecform_end();
		if($this->show_counters != '') {
			$output .= '
<script type="text/javascript">
<!--
	var msgalerted = 0;
	'.$this->show_counters."\n\t\t\t".'
//-->
</script>';
		}
    $output = str_replace(' ',' ',$output);
    $output = str_replace(' />','/>',$output);
		return $output;
	}

	function validate_check() {
		if ( count($this->g_submit) > 0 && $this->validate_check < 0)
			return true;
		else if ( count($this->g_submit) > 0 && $this->validate_check > -1)
			return false;
	}

	function help($which='help') { // PUBLIC
		static $counter = -1;
		if(!is_array($this->helpfile)) {
			if( include_once(dirname(__FILE__).'\helpfile_ec_form.php')) $this->helpfile =& $helpfile;
			else echo '<strong>Help file could not be found</strong>, <a href="www.filepocket.org/rack/fp_form/docs/">visit online documentation?</a>?';
		}
		if(is_array($this->helpfile))	{
			if(isset($this->helpfile[$which])) {
				if( ++$counter < 1) echo $this->helpfile['css'];
				if ($which == 'css_selectors') {
					$filepath = dirname(__FILE__);
					$filepath = str_replace('\\','/',$filepath);
					$str = str_replace( '/', '\/', $_SERVER['DOCUMENT_ROOT']);
					$pattern = '/'.$str.'/i';
					$filepath = preg_replace($pattern, '', $filepath);
					$filepath .= '/images/css_selectors_all.png';
					echo str_replace( '/images/css_selectors_all.png', $filepath, $this->helpfile['css_selectors']);
				}
				else echo $this->helpfile[$which];
			} else {
				echo '<strong>'.$which.'</strong> &gt; could not find item, please check the <strong>ec_form</strong> directory if <strong>helpfile_ec_form.php</strong> exist, or
				visit the <a href="http://www.filepocket.org/rack/ec_form/docs.php" target="_blank">online documentation</a>?<br />';
			}
		}
	}

	function check_range_error($name,$element_type,$required)	{
		$regex_patterns = $this->regex_patterns;
		$warning = '<strong style="color:red">Warning!</strong> Field name: <strong>'.$name.'</strong>. Element type: <strong>'.$element_type.'</strong>';
		// This needs to be optimized
		if (($element_type !== 'checkbox' && $element_type !== 'multiple') && strpos($required,'|'))
			echo $warning.'<br />Will not validate with the Range syntax for validation.<br />';
		else if ($element_type !== 'textarea' && is_numeric($required))
			echo $warning.'<br />Will not validate with integer as validation rule, only textarea elements support integer as character count limits.<br />';
		if ($element_type === 'checkbox' && $required !== '') {
			$expected_msg = '<br />Only accepts the Range syntax. Eg: 1|*, 1|3 (type $obj->help("'.$element_type.'"); for more info)<br />';
			if(strpos($required,'|') < 0)	echo 'Alert';
			$c = explode('|',$required);
			if(count($c) < 2)	echo $warning.$expected_msg;
			else {
				if(!preg_match('/[\d\*]/', $c[0]) || !preg_match('/[\d\*]/', $c[1]))
					echo $warning.'<br />Integer, * and | characters only eg: 1|* minimum one or 1|5 between 1 and 5 selections <br />';
			}
		}
	}

	function external_crosscheck_msg($error_array) {
		$this->external_crosscheck_msg = $error_array;
		++$this->validate_check;
	}

	function check_submission($field_name, $field_value, $field_type, $required_type, $num_of_fields=1) {
		$regex_patterns = $this->regex_patterns; $alert_msg = '';

		if($this->f_validate !== true && $this->submission_counted < 1 && $this->f_start !== '')
			echo '<div>Warning: The <strong>ecform_start()</strong> validation (4th) parameter is set to false or empty, but a form element (<strong>'.$field_name.'</strong>) uses validation rules. <br />To fix: either remove the validation rules for this element or set the ecform_start() validation parameter to true.</div>';
		$submited_array = array();

		if(($this->f_method==='post' || $this->f_method==='get') && @$this->g_submit[$this->form_name] === 'true')	{
			// Checkboxes, multi selection
			if(($field_type==='checkbox' || $field_type==='multiple') && $this->submission_counted > 0 && $required_type !== '')	{
				$req_range = explode('|',$required_type);
				$first_num = $req_range[0]; $second_num = @$req_range[1];
				if($second_num === '*')	$checkbox2='';
				else $checkbox2 = sprintf($this->messages_ec_form[$field_type.'_line2'],$second_num);

				$alert_msg = sprintf($this->messages_ec_form[$field_type.'_line1'],$first_num).$checkbox2;

				if(!array_key_exists($field_name,$this->g_submit)) {
					@$submited_array[$key] = array('value'=>$this->g_submit[$field_name],'err_msg'=>$alert_msg);
					++$this->validate_check;
				}

				foreach($this->g_submit as $key => $val) {
					if($key === $field_name) {
						if($second_num === '*')	$second_num = count($val);
						$counted_val = count($val);
						if($counted_val >= $first_num && $counted_val <= $second_num)
							$submited_array[$key] = array('value'=>$val,'err_msg'=>'');
						else {
							$submited_array[$key] = array('value'=>$val,'err_msg'=>$alert_msg);
							++$this->validate_check;
						}
					}
				}
			}
			else if ($field_type === 'textarea' && $this->submission_counted > 0) {
				$counted_textarea = strlen($this->g_submit[$field_name]);
				if(is_numeric($required_type)) {
					if($counted_textarea > $required_type) {
						$alert_msg = sprintf($this->messages_ec_form['textarea'],$counted_textarea,$required_type);
						++$this->validate_check;
					}
					$submited_array[$field_name] = array('value'=>$this->g_submit[$field_name],'err_msg'=>$alert_msg);
				}
				else if ($required_type !== '') {
					if(!preg_match($regex_patterns[$required_type], $this->g_submit[$field_name]))	{
						$alert_msg = $this->messages_ec_form[$required_type];
						$submited_array[$field_name] = array('value'=>$this->g_submit[$field_name],'err_msg'=>$alert_msg);
						++$this->validate_check;
					}	else $submited_array[$field_name] = array( 'value'=>$this->g_submit[$field_name], 'err_msg'=>'');
				}
			}	else if ($field_type === 'file') {
				if($required_type !== '' && $_FILES[$field_name]['name'] === '') {
					$submited_array[$field_name] = array('value'=>$_FILES[$field_name]['name'],'err_msg'=>$this->messages_ec_form[$required_type]);
					++$this->validate_check;
				}	else if($_FILES[$field_name]['error'] !== 0 && $required_type !== '')	{
					$submited_array[$field_name] = array('value'=>$_FILES[$field_name]['name'], 'err_msg'=>$this->messages_ec_form['UPLOAD_'.$_FILES[$field_name]['error']]);
					++$this->validate_check;
				}
				if($_FILES[$field_name]['error'] === 0)	{
					if($this->upload_dir !== '')
						@move_uploaded_file($_FILES[$field_name]['tmp_name'], $this->upload_dir .'/'. basename($_FILES[$field_name]['name']));
				}
			}	else {
			   foreach($this->g_submit as $key => $val) {
          if($key===$field_name && $required_type!=='') {	// @@ Regular Expression validation here
            if(!is_array($val))	{
              if(preg_match($regex_patterns[$required_type], $val))
                $submited_array[$key] = array( 'value' => $val, 'err_msg' => '');
              else {
                $submited_array[$key] = array( 'value'=>$val, 'err_msg'=>$this->messages_ec_form[$required_type]);
                ++$this->validate_check;
              }
            }
          }	else {
            if($required_type != 'emailorblank') {
              if(empty($this->g_submit[$field_name]) && $required_type !== '') { // For elements with no key or value passed (if nothing selected)
                $submited_array[$key] = array( 'value'=>$val, 'err_msg'=>$alert_msg);
                ++$this->validate_check;
              }	else $submited_array[$key] = array( 'value'=>$val, 'err_msg'=>'');
            }
				  }
			   }
			}
		}
		return $submited_array;
	}

  function customJsValidation($name,$label,$type,$trigger,$required,$errmsg,$withimg='') {  //PUBLIC
    if(is_array($name)) {
      if($trigger) {
    		$this->jsvalidate[$trigger] = array('trigger'=>true,'names'=>$name,'label'=>$label,'type'=>$type,'validate'=>$required,'subgroup'=>$this->subgroup,'curtab'=>$this->current_tab,'cursubtab'=>$this->current_subtab,'cust'=>true,'img'=>$withimg);
    		$this->jsvalerrmsg[$trigger] = $errmsg;
      } else {
        foreach($name as $value) {
          $img=false;
          if(is_array($withimg)) {if(in_array($value,$withimg)) $img=true;}
          else {if($value==$withimg) $img=true;}
      		$this->jsvalidate[$value] = array('label'=>$label,'type'=>$type,'validate'=>$required,'subgroup'=>$this->subgroup,'curtab'=>$this->current_tab,'cursubtab'=>$this->current_subtab,'cust'=>true,'img'=>$img);
      		$this->jsvalerrmsg[$value] = $errmsg;
        }
      }
    } else {
  		$this->jsvalidate[$name] = array('label'=>$label,'type'=>$type,'validate'=>$required,'subgroup'=>$this->subgroup,'curtab'=>$this->current_tab,'cursubtab'=>$this->current_subtab,'cust'=>true,'img'=>$withimg);
  		$this->jsvalerrmsg[$name] = $errmsg;
  	}
  }

  function customResetFormAction($custResetAction) { // PUBLIC
    $this->custResetAction = $custResetAction;
  }

  function JSHeader($customJSHeader='') {
    $regex_patterns = $this->regex_patterns;
		$output = '<script type="text/javascript">
<!--
var hrdotted = "\n- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -\n";
var errMsg_startline = "'.$this->messages_ec_form['js_msg_start'].'" + hrdotted + "\n";
var errMsgEnd = hrdotted+"'.$this->messages_ec_form['js_msg_end'].'";
var bckpReset = new Array(), errorCheck = false;
var formObj = document.getElementById(\''.$this->form_name.'\');';
  $output .= $customJSHeader;
  foreach($regex_patterns as $key => $value) {
   	$output .= "\n\nvar ".$key.' = '.$regex_patterns[$key].';';
   	$output .= "\nvar ".$key.'_msg = "'.$this->messages_ec_form[$key].'";';
  }
  $output .= "\n".'//--></script>
';
  $this->echoJSHeader = true;
  return $output;
  }

	function js_validate_code() { // PUBLIC
		$output='';$curtab = array();$cursubtab = array();$store_label = array(); $trigger = false; $trigvaldt ='';
    if(!$this->echoJSHeader) $output = $this->JSHeader();
	  $output .= '
<script type="text/javascript">
<!--
	function '.$this->js_validate_name.'{';
		$output .= "\n\t\t errorCheck = false;
		var i = 0; var errMsg = ''; var str = '';
";
		$i = 0; $amsg = ''; $popup_amsg = '';

		foreach($this->jsvalidate as $key=>$value) {
			$use_id = false; $use_add_brackets = false;
			if($value['subgroup'] === 'start') {
				if($value['label'] === '') {
					$amsg = ucwords($this->messages_ec_form['field']).' '.++$i.', ';
					$popup_amsg = $sglabel.' '.$this->messages_ec_form['field'].' '.$i;
				}	else {
					$i = 1;
					$amsg = ucwords($this->messages_ec_form['field']).' '.$i.', ';
					$popup_amsg = '';
					$sglabel = $value['label'];
				}
			}	else {
				$amsg = '';
				$popup_amsg = '';
			}
			if($value['validate'] !== '') :
			if(array_key_exists('cust',$value) && $value['cust']) {
			 if(array_key_exists('trigger',$value) && $value['trigger']) {
			    $trigger = true;
    	   	$output .= 'if(!'.$value['validate'].'()){
    	   	';
          foreach($value['names'] as $name) {
            $output .= '
                      if(!bckpReset["'.$name.'"]){bckpReset["'.$name.'"] = new Array(); bckpReset.'.$name.'[0] = "'.$name.'";}
                			formObj.'.$name.'.style.backgroundColor = "'.$this->validate_alert_bgcolor.'";';
            if((is_array($value['img']) && in_array($name,$value['img'])) || $name == $value['img']) {
              $output .= '
                      if(!bckpReset.'.$name.'[1]){bckpReset.'.$name.'[1] = formObj.'.$name.'_img.src; bckpReset.'.$name.'[2] = formObj.'.$name.'_img.getAttribute("tooltiptext");}
                      formObj.'.$name.'_img.src="'.$this->alrt_ico.'";
                      formObj.'.$name.'_img.setAttribute("tooltiptext","'.$this->jsvalerrmsg[$key].'");
                      formObj.'.$name.'_img.setAttribute("template","red");';
            }
            if($value['curtab']) {
              if(!in_array($value['curtab'],$curtab)) array_push($curtab,$value['curtab']);
              $output .= '
                        document.getElementById("'.$value['curtab'].'").setAttribute("style","text-decoration:blink;");';
              if($value['cursubtab']) {
                if(!in_array($value['cursubtab'],$csuburtab)) array_push($cursubtab,$value['cursubtab']);
                $output .= '
                          document.getElementById("'.$value['cursubtab'].'").setAttribute("style","text-decoration:blink;");';
              }
            }
            $trigvaldt .= 'fieldReset("'.$name.'");';
          }
       } else {
  					$output .= 'if(!'.$value['validate'].'()){
            		        if(!bckpReset["'.$key.'"]){bckpReset["'.$key.'"] = new Array(); bckpReset.'.$key.'[0] = "'.$key.'";}
                  			formObj.'.$key.'.style.backgroundColor = "'.$this->validate_alert_bgcolor.'";';
            if($value['img']) $output .= '
                        if(!bckpReset.'.$key.'[1]){bckpReset.'.$key.'[1] = formObj.'.$key.'_img.src; bckpReset.'.$key.'[2] = formObj.'.$key.'_img.getAttribute("tooltiptext");}
                        formObj.'.$key.'_img.src="'.$this->alrt_ico.'";
                        formObj.'.$key.'_img.setAttribute("tooltiptext","'.$this->jsvalerrmsg[$key].'");
                        formObj.'.$key.'_img.setAttribute("template","red");';
          if($value['curtab']) {
            if(!in_array($value['curtab'],$curtab)) array_push($curtab,$value['curtab']);
            $output .= '
                        document.getElementById("'.$value['curtab'].'").setAttribute("style","text-decoration:blink;");';
          }
       }
      } else {
				switch($value['type']) {
				  case 'text': //#########
					$output .= 'if(!formObj.'.$key.'.value.match('.$value['validate'].')){
          		        if(!bckpReset["'.$key.'"]){bckpReset["'.$key.'"] = new Array();bckpReset.'.$key.'[0] = "'.$key.'";bckpReset.'.$key.'[1] = formObj.'.$key.'_img.src;bckpReset.'.$key.'[2] = formObj.'.$key.'_img.getAttribute("tooltiptext");}
                			formObj.'.$key.'.style.backgroundColor = "'.$this->validate_alert_bgcolor.'";
                      formObj.'.$key.'_img.src="'.$this->alrt_ico.'";
                      formObj.'.$key.'_img.setAttribute("tooltiptext","'.$amsg.'"+'.$value['validate'].'_msg);
                      formObj.'.$key.'_img.setAttribute("template","red");';
          if($value['curtab']) {
            if(!in_array($value['curtab'],$curtab)) array_push($curtab,$value['curtab']);
            $output .= '
                      document.getElementById("'.$value['curtab'].'").setAttribute("style","text-decoration:blink;");';
          }
					break;

				  case "textarea": //#########
		 if( strpos($value['validate'],'|'))
			$key_relay = $value['validate'].'_msg';
		 else $key_relay = 'string_msg';
					$output .= '
		'.$key.'_check = false;
		if(isNaN('.$value['validate'].')){ // if not a number
			if(formObj.'.$key.'.value.match('.$value['validate'].') == null){
				'.$key.'_relay = '.$key_relay.';
				'.$key.'_check = true;
			}
		}
		else if ( formObj.'.$key.'.value.length > '.$value['validate'].') {
			'.$key.'_relay = " '.sprintf($this->messages_ec_form['textarea'],0,$value['validate']).'";
			'.$key.'_relay = '.$key.'_relay.replace(/: 0\,/,": "+formObj.'.$key.'.value.length+", ");
			'.$key.'_check = true;
		}
		if( '.$key.'_check == true){
			formObj.'.$key.'.style.backgroundColor = "'.$this->validate_alert_bgcolor.'";
//			document.getElementById("'.$key.'_amsg").innerHTML = "'.$amsg.'"+'.$key.'_relay;';
					break;

				  case "radio": //#########
				  	$output .= '
		'.$key.'_count = formObj.'.$key.'.length;
		'.$key.'_check = false;

			for(i=0;i<'.$key.'_count;i++){
				if( formObj.'.$key.'[i].checked == true)
					'.$key.'_check = true;
			}
			if('.$key.'_check == false){
				document.getElementById("'.$key.'_span").style.backgroundColor = "'.$this->validate_alert_bgcolor.'";
//				document.getElementById("'.$key.'_amsg").innerHTML = "'.$amsg.'"+'.$value['validate'].'_msg';
					$use_id = true;
				  	break;

				  case "checkbox": //#########
			$req_range = explode('|',$value['validate']);
				  	$output .= '
			'.$key.'_count = formObj["'.$key.'[]"].length;
			var first_num = "'.$req_range[0].'";
			var second_num = "'.@$req_range[1].'";
			var js_tally = 0;
			'.$key.'_check = false;

			for(i=0;i<'.$key.'_count;i++){
				if( formObj["'.$key.'[]"][i].checked == true)
					js_tally++;
			}';
					$output .= '
		checkbox_msg = '.sprintf('"'.$this->messages_ec_form[$value['type'].'_line1'].'";', $value['validate'][0]);
					if($value['validate'][2] > 0)
						$output .= "\n".'checkbox_msg += '.sprintf('"'+$this->messages_ec_form[$value['type'].'_line2'],$value['validate'][2]).'";';

					$output .= '
			if(second_num == "*")
				second_num = '.$key.'_count;
			if( js_tally >= first_num && js_tally <= second_num)
				'.$key.'_check = true;';

					$output .= '
		if('.$key.'_check == false){
			document.getElementById("'.$key.'_span").style.backgroundColor = "'.$this->validate_alert_bgcolor.'";
//			document.getElementById("'.$key.'_amsg").innerHTML = "'.$amsg.'"+'.'checkbox_msg;';
					$use_id = true;
				  	break;

				  case 'multiple': //#########
			$key = $key.'[]';
			$key_clean = str_replace('[]','',$key);
				  	$output .= '
			'.$key_clean.'_count = formObj["'.$key.'"].length;
			var first_num = "'.$value['validate'][0].'";
			var second_num = "'.$value['validate'][2].'";
			var js_tally = 0;
			'.$key_clean.'_check = false;

			for(i=0;i<'.$key_clean.'_count;i++){
				if( formObj["'.$key.'"][i].selected == true){
					js_tally++;
				}
			}';

					$output .= '
		checkbox_msg = '.sprintf('"'.$this->messages_ec_form[$value['type'].'_line1'].'";', $value['validate'][0]);
					if($value['validate'][2] > 0)
						$output .= "\n".'checkbox_msg += '.sprintf('"'+$this->messages_ec_form[$value['type'].'_line2'],$value['validate'][2]).'";';

					$output .= '
			if( second_num == "*")
				second_num = '.$key_clean.'_count;
			if( js_tally >= first_num && js_tally <= second_num)
				'.$key_clean.'_check = true;';

					$output .= '
		if('.$key_clean.'_check == false){
			formObj["'.$key.'"].style.backgroundColor = "'.$this->validate_alert_bgcolor.'";
//			document.getElementById("'.$key_clean.'_amsg").innerHTML = checkbox_msg;';
			$use_add_brackets = true;
				  break;

				  case "select": //#########
				  	$output .= '
		if(formObj.'.$key.'.value.match('.$value['validate'].') == null){
			formObj["'.$key.'"].style.backgroundColor = "'.$this->validate_alert_bgcolor.'";
//			document.getElementById("'.$key.'_amsg").innerHTML = "'.$amsg.'"+'.$value['validate'].'_msg;';
				  	break;

				 case "file": //#########
					$output .= '
		if(formObj.'.$key.'.value.match('.$value['validate'].') == null){
			formObj.'.$key.'.style.backgroundColor = "'.$this->validate_alert_bgcolor.'";
//			document.getElementById("'.$key.'_amsg").innerHTML = "'.$amsg.'"+'.$value['validate'].'_msg;';
				  	break;

				  default: //#########
				  	$output .= '
		if(formObj.'.$key.'.value.match('.$value['validate'].') == null){
			formObj["'.$key.'"].style.backgroundColor = "'.$this->validate_alert_bgcolor.'";
//			document.getElementById("'.$key.'_amsg").innerHTML = "'.$amsg.'"+'.$value['validate'].'_msg;';
					break;
				}
			}
				// This part universal $popup_amsg
		if(in_array($value['label'],$store_label)) {
        $output .= '
			errorCheck = true;
		} else {';
    } else {
				$output .= '
			errMsg += " - '.$popup_amsg.$value['label'].'\n";
			errorCheck = true;
		} else {';
		  array_push($store_label,$value['label']);
    }
/*		if($value['type'] === 'multiple') // exception for multiple select fileds only - needs to have [] in fieldname
			$output .= 'document.getElementById("'.$key_clean.'_amsg").innerHTML = ""; ';
		else
			$output .= 'document.getElementById("'.$key.'_amsg").innerHTML = ""; ';
*/
		if($use_id == true)
			$output .= 'document.getElementById("'.$key.'_span").style.backgroundColor = "transparent";// '.$this->validate_pass_bgcolor.'';
		else if ($use_add_brackets == true)
			$output .= 'formObj["'.$key.'"].style.backgroundColor = "'.$this->validate_pass_bgcolor.'";';
		else
     if($trigger) {$output .= "\n".$trigvaldt; $trigvaldt =''; $trigger = false;}
     else $output .= 'fieldReset("'.$key.'");';

		$output .= "}\n\t";

		 endif; // end of If $value['validate'] !== ''
		}

		$output .= '
		if(errorCheck == true)
		{';
		if( ($this->validate_check > 0 && count($this->fields) > 5) || $this->show_alert_hdr == true)
			$output .= 'document.getElementById("alertHdr").innerHTML = errMsg_startline;';
		$output .= '
			alert( errMsg_startline + errMsg + errMsgEnd);
			return false;
		} else {
			return true;
		}';
		$output .= "\n".'   }
          function fieldReset(f,d){
              if(typeof(bckpReset[f])!="object") return;
              document.getElementById(bckpReset[f][0]).style.backgroundColor=(d==null)?"'.$this->validate_pass_bgcolor.'":d;
              if(bckpReset[f][1]){
                document.getElementById(bckpReset[f][0]+"_img").src=bckpReset[f][1];
                document.getElementById(bckpReset[f][0]+"_img").setAttribute("tooltiptext",(bckpReset[f][1].search("blank")>0)? "":bckpReset[f][2]);
                document.getElementById(bckpReset[f][0]+"_img").setAttribute("template","");
              }
          }
          function ecformReset(){
            if (confirm("'.$this->messages_ec_form["resetconfirm"].'")) {
              document.'.$this->form_name.'.reset();';
    $cpt = count($curtab);
    for($i=0;$i<$cpt;$i++) $output .= '
              document.getElementById("'.$curtab[$i].'").setAttribute("style","text-decoration:none;");';             
    if($this->custResetAction) $output .= $this->custResetAction;
    $output .= 'for(var indx in bckpReset) fieldReset(indx);';
    $output .= '
           }
         }'."\n".'//-->
</script>'."\n";
		return $output;
	}
}
?>