<?php
if(!class_exists('EC_Management')):

class EC_Management { // Dashboard management, widget control and edit options
  var $month;
  var $year;
  var $deflinkout;
  var $calendar;
  var $db;

  function EC_Management() {
    $this->month = $_GET['EC_action'] == 'switchMonthAdmin' ? $_GET['EC_month'] : date('m');
    $this->year = $_GET['EC_action'] == 'switchMonthAdmin' ? $_GET['EC_year'] : date('Y');
    $this->deflinkout = "http://";
    $this->db = new EC_DB();
  }

  function display() {
    global $wpdb;
    // Return Form Post : Add a New Event
    if(isset($_POST['EC_addEventForm_submitted'])) {
      //echo var_dump($_POST);
      $title = $wpdb->escape($_POST['EC_title']);
      $type = isset($_POST['EC_type']) ? $_POST['EC_type'] : _c('No Event Type','events-calendar');
      $description = $wpdb->escape($_POST['EC_description']);
      $startDate = isset($_POST['EC_startDate']) && !empty($_POST['EC_startDate'])? $_POST['EC_startDate'] : date('Y-m-d');
      $endDate = isset($_POST['EC_endDate']) && !empty($_POST['EC_endDate'])? (strcmp($startDate, $_POST['EC_endDate']) > 0 ? $startDate : $_POST['EC_endDate']) : $startDate;
      $startTime = isset($_POST['EC_startTime']) && !empty($_POST['EC_startTime']) ? $_POST['EC_startTime'] : null;
      $endTime = isset($_POST['EC_endTime']) && !empty($_POST['EC_endTime']) ? $_POST['EC_endTime'] : null;
      $location = isset($_POST['EC_location']) && !empty($_POST['EC_location']) ? $wpdb->escape($_POST['EC_location']) : null;
      $linkout = isset($_POST['EC_linkout']) && !empty($_POST['EC_linkout']) && ($_POST['EC_linkout'] != $this->deflinkout) ? $wpdb->escape($_POST['EC_linkout']) : null;
      $tdevt = isset($_POST['EC_tdevt']) ?  true: false;
      $phase = $_POST['EC_phase'];
      $participation = $_POST['EC_participation'];
      $accessLevel = $_POST['EC_accessLevel'];
      $ec_adress = $wpdb->escape($_POST['EC_street'].'|'.$_POST['EC_city'].'|'.$_POST['EC_zip'].'|'.$_POST['EC_country'].'|'.$_POST['EC_state']);
      $ec_adress = ($ec_adress=="||||")? "":$ec_adress;
      $googlemaplink = $wpdb->escape(htmlentities($_POST['EC_googlemaplink'],ENT_QUOTES));
      $ec_contacts = $wpdb->escape($_POST['EC_contact_manager'].'|'.$_POST['EC_phone_manager'].'|'.$_POST['EC_email_manager'].'|'.$_POST['EC_contact_person'].'|'.$_POST['EC_phone_person'].'|'.$_POST['EC_email_person']);
      $ec_contacts = ($ec_contacts=="|||||")? "":$ec_contacts;
      $ec_costs = $wpdb->escape($_POST['EC_cost_nbpeople'].'|'.$_POST['EC_cost_cost']);
      $ec_costs = ($ec_costs=='|')? "":$ec_costs;
      $ec_cfields = $wpdb->escape($_POST['EC_custfield_1'].'|'.$_POST['EC_custfield_2'].'|'.$_POST['EC_custfield_3'].'|'.$_POST['EC_custfield_4'].'|'.$_POST['EC_custfield_5'].'|'.$_POST['EC_custfield_6']);
      $ec_cfields = ($ec_cfields=="|||||")? "":$ec_cfields;
      $adminotes = $wpdb->escape($_POST['EC_admin_notes']);
      $excptArr = $wpdb->escape(htmlentities($_POST['EC_excptarr'],ENT_QUOTES));
      $options = get_option('optionsEventsCalendar');
      $output = "<strong>"._c('Title','events-calendar').": </strong>$title<br />";
      if($location) $output .= "<strong>"._c('Location','events-calendar').": </strong>$location<br />";
      if($linkout)  $output .= "<strong>"._c('Link out','events-calendar').": </strong><a href=\"".$linkout."\" target=\"_blanck\">"._c('Click here','events-calendar')."</a><br />";
      if($description) $output .= "<strong>"._c('Description','events-calendar').":<br /></strong>$description<br />";
      if($startDate != $endDate ) {
        list($ec_startyear, $ec_startmonth, $ec_startday) = explode('-', $startDate);
        $output .= "<strong>"._c('Start Date','events-calendar').": </strong>".date($options['dateFormatLarge'], mktime(0, 0, 0, $ec_startmonth, $ec_startday, $ec_startyear))."<br />";
      }
      if($startTime) {
        list($ec_starthour, $ec_startminute, $ec_startsecond) = explode(":", $startTime);
        $output .= "<strong>"._c('Start Time','events-calendar').": </strong>".date($options['timeFormatLarge'], mktime($ec_starthour, $ec_startminute, $ec_startsecond, $ec_startmonth, $ec_startday, $ec_startyear))."<br />";
      }
      if($startDate != $endDate) {
        list($ec_endyear, $ec_endmonth, $ec_endday) = explode('-', $endDate);
        $output .= "<strong>"._c('End Date','events-calendar').": </strong>".date($options['dateFormatLarge'], mktime(0, 0, 0, $ec_endmonth, $ec_endday, $ec_endyear))."<br />";
      } else {
        list($ec_startyear, $ec_startmonth, $ec_startday) = explode('-', $startDate);
        $output .= "<strong>"._c('Date','events-calendar').": </strong>".date($options['dateFormatLarge'], mktime(0, 0, 0, $ec_startmonth, $ec_startday, $ec_startyear))."<br />";
      }
      if($endTime || !is_null($endTime) && !is_null($startTime)) {
        list($ec_endhour, $ec_endminute, $ec_endsecond) = explode(":", $endTime);
        $output .= "<strong>"._c('End Time','events-calendar').": </strong>".date($options['timeFormatLarge'], mktime($ec_endhour, $ec_endminute, $ec_endsecond, $ec_endmonth, $ec_endday, $ec_endyear))."<br />";
      }
      $post_id = null;
      if(isset($_POST['EC_doPost'])) {
        $post_category[0] = $_POST['EC_CatPost'];
        $statusPost = $_POST['EC_statusPost'];
        $data = array(
            'post_content' => $output
          , 'post_title' => $title
          , 'post_date' => date('Y-m-d H:i:s')
          , 'post_category' => $post_category
          , 'post_status' => $statusPost
          , 'post_author' => $wpdb->escape($this->blog_post_author)
        );
        $post_id = wp_insert_post($data);
        $results = $this->db->getLatestPost();
        $postID = $results[0]->id;
      }
      if (isset($_POST['EC_reccStatus'])) {
        while (isset($_POST['EC_reccStatus'])) {
          if(isset($_POST['EC_reccbDate']) && isset($_POST['EC_recDate'])) {
            if ($_POST['EC_recDate'] == '') $_POST['EC_recDate'] = $ec_startday;
            $duration = $_POST['EC_recDateDur'];
            $recurrStatus = 1; $recurrProces = $_POST['EC_recDate'].'|'.($duration?($duration>27?"27":$duration):"1"); break;
          }
          if(isset($_POST['EC_reccbXDay']) && isset($_POST['EC_recXDay'])) {
            if ($_POST['EC_recXDay']=='') $_POST['EC_recXDay'] = 1;
            $duration = $_POST['EC_recXDayDur']; $xdays = $_POST['EC_recXDay'];
            $duration = ($duration)? ((intval($duration)>intval($xdays)-1)? strval(intval($xdays)-1):$duration):"1";
            if(isset($_POST['EC_reccbWeek']) && isset($_POST['EC_reccbNWeek'])) {
              $recurrStatus = 6 ; $recurrProces = $xdays.'|'.$duration.'|'.serialize($_POST['EC_reccbNWeek']); break;
            } else {
              $recurrStatus = 2 ; $recurrProces = $xdays.'|'.$duration; break;
            }
          }
          if(isset($_POST['EC_reccbDay']) && isset($_POST['EC_reccbWDay'])) {
            if(isset($_POST['EC_reccbWeek']) && isset($_POST['EC_reccbNWeek'])) {
              $recurrStatus = 7 ; $recurrProces = serialize($_POST['EC_reccbWDay']).'|'.serialize($_POST['EC_reccbNWeek']); break;
            } else {
              $recurrStatus = 3 ; $recurrProces = serialize($_POST['EC_reccbWDay']); break;
            }
          }
          if(isset($_POST['EC_reccbWeek']) && isset($_POST['EC_reccbNWeek'])) {
            $recurrStatus = 4 ; $recurrProces = serialize($_POST['EC_reccbNWeek']); break;
          }
          if(isset($_POST['EC_reccbAnnual'])) {
            $recurrStatus = 8; $recurrProces = $endDate; break;
          }
          break;
        }
      } else {
        $recurrStatus = null; $recurrProces = null;
      }
      $this->addEvent($title, $type, $description, $startDate, $endDate, $startTime,  $endTime, $location, $linkout, $phase, $participation, $accessLevel, $postID, $ec_adress, $googlemaplink, $ec_contacts, $ec_costs, $ec_cfields, $adminotes, $recurrStatus, $recurrProces, $excptArr, $tdevt);
      //list($this->year,$this->month,$ddd) = split('-', $startDate);
    }
    // Return Form Post : Edit an Event
    if(isset($_POST['EC_editEventForm_submitted'])) {
      //echo var_dump($_POST);
      //echo 'EC_recDate = ',$_POST['EC_recDate'];
      $id = $_POST['EC_id'];
      $title = $wpdb->escape($_POST['EC_title']);
      $type = isset($_POST['EC_type']) ? $_POST['EC_type'] : _c('No Event Type','events-calendar');
      $description = $wpdb->escape($_POST['EC_description']);
      $startDate = isset($_POST['EC_startDate']) && !empty($_POST['EC_startDate'])? $_POST['EC_startDate'] : date('Y-m-d');
      list($ec_startyear, $ec_startmonth, $ec_startday) = explode('-', $startDate);
      $endDate = isset($_POST['EC_endDate']) && !empty($_POST['EC_endDate'])? (strcmp($startDate, $_POST['EC_endDate']) > 0 ? $startDate : $_POST['EC_endDate']) : $startDate;
      $startTime = isset($_POST['EC_startTime']) && !empty($_POST['EC_startTime']) ? $_POST['EC_startTime'] : null;
      $endTime = isset($_POST['EC_endTime']) && !empty($_POST['EC_endTime']) ? $_POST['EC_endTime'] : null;
      $location = isset($_POST['EC_location']) && !empty($_POST['EC_location']) ? $wpdb->escape($_POST['EC_location']) : null;
      $linkout = isset($_POST['EC_linkout']) && !empty($_POST['EC_linkout']) && ($_POST['EC_linkout'] != $this->deflinkout) ? $wpdb->escape($_POST['EC_linkout']) : null;
      $tdevt = isset($_POST['EC_tdevt']) ?  true: false;
      $phase = $_POST['EC_phase'];
      $participation = $_POST['EC_participation'];
      $accessLevel = $_POST['EC_accessLevel'];
      $ec_adress = $wpdb->escape($_POST['EC_street'].'|'.$_POST['EC_city'].'|'.$_POST['EC_zip'].'|'.$_POST['EC_country'].'|'.$_POST['EC_state']);
      $ec_adress = ($ec_adress=="||||")? "":$ec_adress;
      $googlemaplink = $wpdb->escape(htmlentities($_POST['EC_googlemaplink'],ENT_QUOTES));
      $ec_contacts = $wpdb->escape($_POST['EC_contact_manager'].'|'.$_POST['EC_phone_manager'].'|'.$_POST['EC_email_manager'].'|'.$_POST['EC_contact_person'].'|'.$_POST['EC_phone_person'].'|'.$_POST['EC_email_person']);
      $ec_contacts = ($ec_contacts=="|||||")? "":$ec_contacts;
      $ec_costs = $wpdb->escape($_POST['EC_cost_nbpeople'].'|'.$_POST['EC_cost_cost']);
      $ec_costs = ($ec_costs=='|')? "":$ec_costs;
      $ec_cfields = $wpdb->escape($_POST['EC_custfield_1'].'|'.$_POST['EC_custfield_2'].'|'.$_POST['EC_custfield_3'].'|'.$_POST['EC_custfield_4'].'|'.$_POST['EC_custfield_5'].'|'.$_POST['EC_custfield_6']);
      $ec_cfields = ($ec_cfields=="|||||")? "":$ec_cfields;
      $adminotes = $wpdb->escape($_POST['EC_admin_notes']);
      $excptArr = $wpdb->escape(htmlentities($_POST['EC_excptarr'],ENT_QUOTES));
      $postID = isset($_POST['EC_postID']) && !empty($_POST['EC_postID']) ? $_POST['EC_postID'] : null;
      if (isset($_POST['EC_reccStatus'])) {
        while (isset($_POST['EC_reccStatus'])) {
          if(isset($_POST['EC_reccbDate']) && isset($_POST['EC_recDate'])) {
            if ($_POST['EC_recDate'] == '') $_POST['EC_recDate'] = $ec_startday;
            $duration = $_POST['EC_recDateDur'];
            $recurrStatus = 1; $recurrProces = $_POST['EC_recDate'].'|'.($duration?($duration>27?"27":$duration):"1"); break;
          }
          if(isset($_POST['EC_reccbXDay']) && isset($_POST['EC_recXDay'])) {
            if ($_POST['EC_recXDay']=='') $_POST['EC_recXDay'] = 1;
            $duration = $_POST['EC_recXDayDur']; $xdays = $_POST['EC_recXDay'];
            $duration = ($duration)? (($duration>$xdays-1)? ($xdays-1):$duration):"1";
            if(isset($_POST['EC_reccbWeek']) && isset($_POST['EC_reccbNWeek'])) {
              $recurrStatus = 6 ; $recurrProces = $xdays.'|'.$duration.'|'.serialize($_POST['EC_reccbNWeek']); break;
            } else {
              $recurrStatus = 2 ; $recurrProces = $xdays.'|'.$duration; break;
            }
          }
          if(isset($_POST['EC_reccbDay']) && isset($_POST['EC_reccbWDay'])) {
            if(isset($_POST['EC_reccbWeek']) && isset($_POST['EC_reccbNWeek'])) {
              $recurrStatus = 7 ; $recurrProces = serialize($_POST['EC_reccbWDay']).'|'.serialize($_POST['EC_reccbNWeek']); break;
            } else {
              $recurrStatus = 3 ; $recurrProces = serialize($_POST['EC_reccbWDay']); break;
            }
          }
          if(isset($_POST['EC_reccbWeek']) && isset($_POST['EC_reccbNWeek'])) {
            $recurrStatus = 4 ; $recurrProces = serialize($_POST['EC_reccbNWeek']); break;
          }
          if(isset($_POST['EC_reccbAnnual'])) {
            $recurrStatus = 8; $recurrProces = $endDate; break;
          }
          break;
         }
      } else {
        $recurrStatus = null; $recurrProces = null;
      }
      $this->editEvent($id, $title, $type, $description, $startDate, $endDate, $startTime,  $endTime, $location, $linkout, $phase, $participation, $accessLevel, $postID, $ec_adress, $googlemaplink, $ec_contacts, $ec_costs, $ec_cfields, $adminotes, $recurrStatus, $recurrProces, $excptArr, $tdevt);
      //list($this->year,$this->month,$ddd) = split('-', $startDate);
    }
    if($_GET['EC_action'] == 'edit') {
      class_exists('EC_ManageEvents') || require(EVENTSCALENDARCLASSPATH . '/ec_manage-event.class.php');
      $this->manevent = new EC_ManageEvents();
      $this->manevent->ec_manEventsForm($_GET['EC_id'],$_GET['EC_month'],$_GET['EC_year']);
    }
    else {
      class_exists('EC_ACalendar') || require(EVENTSCALENDARCLASSPATH . '/ec_admin-calendar.class.php');
      $this->calendar = new EC_ACalendar();
      $this->calendar->displayAdmin($this->year, $this->month);
      //$this->calendar->calendarData($this->month, $this->year);
    }
  }
  function addEvent($title, $type, $description, $startDate, $endDate, $startTime,  $endTime, $location, $linkout, $phase, $participation, $accessLevel, $postID, $ec_adress, $googlemaplink, $ec_contacts, $ec_costs, $ec_cfields, $adminotes, $recurrStatus, $recurrProces, $excptArr, $tdevt) {
    global $current_user; get_currentuserinfo(); $creator = $current_user->user_login; //echo $creator;
    $this->db->addEvent($title, $type, $description, $startDate, $endDate, $startTime,  $endTime, $location, $linkout, $phase, $participation, $accessLevel, $postID, $ec_adress, $googlemaplink, $ec_contacts, $ec_costs, $ec_cfields, $adminotes, $recurrStatus, $recurrProces, $excptArr, $tdevt, $creator);
    return;
  }

  function editEvent($id, $title, $type, $description, $startDate, $endDate, $startTime,  $endTime, $location, $linkout, $phase, $participation, $accessLevel, $postID, $ec_adress, $googlemaplink, $ec_contacts, $ec_costs, $ec_cfields, $adminotes, $recurrStatus, $recurrProces, $excptArr, $tdevt) {
    $this->db->editEvent($id, $title, $type, $description, $startDate, $endDate, $startTime,  $endTime, $location, $linkout, $phase, $participation, $accessLevel, $postID, $ec_adress, $googlemaplink, $ec_contacts, $ec_costs, $ec_cfields, $adminotes, $recurrStatus, $recurrProces, $excptArr, $tdevt);
  }
}
endif;
?>