<?php
if(!class_exists("EC_WCalendar")) :

class EC_WCalendar {

  function EC_WCalendar() {
    wpec_get_option($this,'wpecOptionsGenSet');
    /*
    $this->ecopt_mtt     Tooltip method :
            jQuery Tooltips = 'ecopt_mttjq' -> 'Jtts' (default)
            EC-Tooltips     = 'ecopt_mttec' -> 'Ectt'
            Css Tooltips    = 'ecopt_mtcss' -> 'Csstt'
            None            = 'ecopt_mttnone'

    $this->ecopt_weopt   Weekends :
            Universal       = 'ecopt_weuni' -> default
            Semi universal  = 'ecopt_wesun'
            Custom          = 'ecopt_wecust': select ecopt_cwe
    */
    wpec_get_option($this,'wpecOptionsWc');
    /*
        * Length names weekdays   : text          ecopt_wc_wdl            int              3  rec old version
        * EC, dominant color      : text          ecopt_wc_ecdc           text             #173b6d
        * Post Cal.dominant color : text          ecopt_wc_pcdc           text             #4fa8c9
        * Today date color        : text          ecopt_wc_todaydcol      text             #9d0a0f
        * Today Background image  : select        ecopt_wc_todaybgimg     list values      empty
        * Today Background color  : text          ecopt_wc_todaybgcol     text             #fff
        - Widget Calendar tabs    :fieldset
        * Allow calendar tabs?    : cbtrigger     ecopt_wc_tabs           boolean          on
        * Tab list settings       : text          ecopt_sertabs           serialized
            ecopt_wc_sertabs = "a:5:{i:0;a:3:{s:3:"tab";s:15:"Switch calendar";s:3:"col";s:7:"#173b6d";s:3:"enb";s:3:"Yes";}i:1;a:3:{s:3:"tab";s:6:"Filter";s:3:"col";s:7:"#4e7c9d";s:3:"enb";s:3:"Yes";}i:2;a:3:{s:3:"tab";s:6:"Search";s:3:"col";s:7:"#719fd1";s:3:"enb";s:3:"Yes";}i:3;a:3:{s:3:"tab";s:11:"Today event";s:3:"col";s:7:"#c0c0c0";s:3:"enb";s:3:"Yes";}i:4;a:3:{s:3:"tab";s:3:"Add";s:3:"col";s:7:"#000000";s:3:"enb";s:3:"Yes";}}"
        * Post'it img Today Event : select        ecopt_wc_bkimgtde       list values      "tdevt1.png"
        - Thickbox Settings       :fieldset
        * Date Format             : select        ecopt_wc_tbdf           list values      first of the list
        * Time Format             : select        ecopt_wc_tbtf           list values      first of the list
        * Title Date Format       : select        ecopt_wc_dftt           list values      first of the list
        - Display by order        :fieldset
        * Event Type              : select        ecopt_wc_tbd_evt        list values      2  / = 0 & disabled if no Event Types Management
        * Description             : select        ecopt_wc_tbd_des        list values      1
        * Location                : select        ecopt_wc_tbd_loc        list values      = 3 if Extend Tab not allowed OR Address empty
        * Link out                : select        ecopt_wc_tbd_lko        list values      3
        * Address                 : select        ecopt_wc_tbd_adr        list values      fs Address / = 0 & disabled if Extend Tab not allowed
        * Manager                 : select        ecopt_wc_tbd_man        list values      fs Contact / = 0 & disabled if Extend Tab not allowed
        * Contact                 : select        ecopt_wc_tbd_ctc        list values      fs Contact / = 0 & disabled if Extend Tab not allowed
        * Phase                   : select        ecopt_wc_tbd_pha        list values      fs Status  / = 0 & disabled if no Phase
        * Participation           : select        ecopt_wc_tbd_par        list values      fs Status  / = 0 & disabled if no Participation
        * Cost                    : select        ecopt_wc_tbd_cst        list values      4
        * Post link               : select        ecopt_wc_tbd_lkp        list values      5
        * GMap link               : select        ecopt_wc_tbd_lkg        list values      6 / Only if Goggle Maps iFrame = 0
        * GMap iFrm               : select        ecopt_wc_tbd_ggm        list values      14 Allways last fs
        * Custom fields           : select        ecopt_wc_tbd_csf        list values      fs
        - Tooltips Settings       :fieldset
        * Date Format             : select        ecopt_wc_ttdf           list values      first of the list
        * Time Format             : select        ecopt_wc_tttf           list values      first of the list
        * Fixed?                  : cbtrigger     ecopt_wc_fixed          boolean          off : Useful if links are to click in the tooltip
        * Display                 : checkboxes    ecopt_wc_tt_disp        boolean array    all on / Phase & Participation disabled if no Phase or no Participation
    */
    // If calendar tabs allowed
    /*
    * Tab list settings       : text          ecopt_sertabs           serialized
    */
    if(isset($this->ecopt_wc_tabs)) {
      // Yes No translated    
      $yesno = explode(':',_c('Yes:No','events-calendar'));
      $this->yes = $yesno[0];
      $this->no = $yesno[1];
      wpec_get_option($this,'wpecOptionsTabs');
      $wc_tabs = mb_unserialize(html_entity_decode(stripslashes($this->ecopt_sertabs)));
      $this->wc_tabs_switch = $wc_tabs[0];
      $this->wc_tabs_filter = $wc_tabs[1];
      $this->wc_tabs_search = $wc_tabs[2];
      $this->wc_tabs_today = $wc_tabs[3];
      $this->wc_tabs_addevt = $wc_tabs[4];

      
      //echo var_dump($wc_tabs_addevt); die;      
      /*
      array(5) {
      [0]=>  array(3) { ["tab"]=>  string(15) "Switch calendar" ["col"]=>  string(7) "#173b6d" ["enb"]=>  string(3) "Oui" }
      [1]=>  array(3) { ["tab"]=>  string(6) "Filter" ["col"]=>  string(7) "#4e7c9d" ["enb"]=>  string(3) "Oui" }
      [2]=>  array(3) { ["tab"]=>  string(6) "Search" ["col"]=>  string(7) "#719fd1" ["enb"]=>  string(3) "Oui" }
      [3]=>  array(3) { ["tab"]=>  string(11) "Today event" ["col"]=>  string(7) "#c0c0c0" ["enb"]=>  string(3) "Oui" }
      [4]=>  array(3) { ["tab"]=>  string(3) "Add" ["col"]=>  string(7) "#000000" ["enb"]=>  string(3) "Non" } }
      */
    }
  }
  /**
   * Displays the Widget Calendar
   */
	 function displayWidget($year, $month, $inman = false ) {
    global $ec_WeekdayNames, $ec_MonthNames;
    if(isset($_GET['EC_month']) && isset($_GET['EC_year'])) {
      $year = $_GET['EC_year']; $month = $_GET['EC_month'];
    }
    if(isset($_GET['EC_toggle']) && $_GET['EC_toggle'] == 'yes') $toggle_post = 'yes'; else $toggle_post = 'no';
    $options = get_option('optionsEventsCalendar');
    $day_name_length = $options['daynamelength'];
		// Option : Is the CSS adapted for your site ?
		$adaptedCSS = $options['adaptedCSS'];
		// If not we prepare the CSS style for ToDay
		$todayCSS = '';
		if(!$adaptedCSS) $todayCSS= isset($options['todayCSS']) && !empty($options['todayCSS']) ? $options['todayCSS'] : 'border:thin solid blue;font-weight: bold;background-color: #a8c3d6;';
    $first_of_month = gmmktime(0,0,0,$month,1,$year);
	  $day_names = array();
    for ($i=WPECFDW;$i<(7+WPECFDW) ;$i++ ) {
    	if ($i>6) $n=($i-7); else $n=$i;
      $day_names[$i] = $ec_WeekdayNames[$n];
    }
	  list($month, $year, $month_name, $weekday) = explode(',',gmstrftime('%m,%Y,%B,%w',$first_of_month));
	  $weekday = ($weekday + 7 - WPECFDW) % 7; //adjust for $first_day
		$title   = $ec_MonthNames[intval($month)].'&nbsp;'.$year;
		if ($inman == true) $calendar .='<div id="ecform_wcalendar">';
		$calendar .= '<div id="evcalendar_wrap">'."\n";
	  $calendar .= '<div id="buttoptblk"><span id ="buttopt-1" class="buttoptcl"></span><span id ="buttopt-2" class="buttoptcl"></span><span id ="buttopt-3" class="buttoptcl"></span><span id ="buttopt-4" class="buttoptcl"></span><span id ="buttopt-5" class="buttoptcl"></span></div>';
	  $calendar .= '<div id="encaptdevt" style="position:relative;"><div id="tdevt" style="display:none;position:absolute;left:12px;"><div id="msg-tdevt" style="position:relative;top:40px;left:12px;">'._c('No distinguished event today. Maybe later...','events-calendar').'</div><span id="tdevtimg" style="position:absolute;top:150px;left:65px;"><img id="tdevtimg-fg"/><img id="tdevtimg-fd"/></span></div></div>';
    $calendar .= '<table width=96%" summary="Event Calendar" id="wp-calendar">'."\n".'<thead></tr><tr><td id="EC_tdrwMonth" colspan="1"><span id="EC_rwMonth"></span></td><td id="calendar-month" colspan="5" rel="'.$year.'-'.$month.'">'.$title.'</td><td id="EC_tdffMonth" colspan="1"><span id="EC_ffMonth"></span></td><tr>';
	  if($day_name_length){ //if the day names should be shown ($day_name_length > 0)
		  //if day_name_length is >3, the full name of the day will be printed
		  foreach($day_names as $d)
			  $calendar .= '<th abbr="'.$d.'" scope="col" title="'.$d.'">'.($day_name_length < 4 ? ec_utf8_substr($d,0,$day_name_length) : $d).'</th>'."\n";
		  $calendar .= '</tr></thead><tfoot><tr><td class="pad" colspan="3"><span id="EC_SelectMonth"></span></td><td class="pad" colspan="1" id="EC_loadingPane" style="text-align:center;"></td><td class="pad" colspan="3"><span id="EC_SelectYear"></span></td></tr></tfoot><tbody><tr>';
	  }
	  if($weekday > 0) $calendar .= '<td colspan="'.$weekday.'" class="padday">&nbsp;</td>'; //initial \"empty\" days
	  $buttID = 0;
	  for($day=1,$days_in_month=gmdate('t',$first_of_month); $day<=$days_in_month; $day++,$weekday++){
		  if($weekday == 7){
			  $weekday   = 0; //start a new week
			  $buttID++;
			  $calendar .= "</tr>\n<tr>";
		  }
			$dayID = '';
			if ("$month/$day/$year" == date('m/j/Y'))
				$dayID = !$adaptedCSS ? ' id="todayWidget" style="'.$todayCSS.'" ' : ' id="today" ';
		  $calendar .= '<td'.$dayID.'><span id="events-calendar-'.$day.'"><a class="thickbox">'.$day.'</a></span></td>'."\n";
	  }
	  if($weekday != 7) $calendar .= "\n\t\t<td colspan=\"".(7-$weekday)."\" class=\"padday\">&nbsp;</td>"; //remaining "empty" days
	  $calendar .= "\n</tr></tbody></table>\n";
    $calendar .= '<script type="text/javascript">'."\n".'// <![CDATA['."\n";
    $calendar .= '  var tdevtarr = new Array(), tdi;';
		$calendar .= '  tb_pathToImage = "'.get_bloginfo('wpurl').'/wp-includes/js/thickbox/loadingAnimation.gif";'."\n";
		$calendar .= '  tb_closeImage = "'.get_bloginfo('wpurl').'/wp-includes/js/thickbox/tb-close.png";'."\n";
		if ($inman == true)
      $calendar .= '  var ecd = {}; ecd.jq = jQuery.noConflict();'."\n".'  (function($) {'."\n".'    ecd.jq(document).ready(function() {'."\n";
		  else $calendar .= '  jQuery.noConflict();'."\n".'  (function($) {'."\n".'    ecd.jq(document).ready(function() {'."\n";
		echo $calendar;
		// echo "alert('toggle_post=".$_GET['EC_toggle']."');\n";
		if ($toggle_post == 'yes') {
      $this->calendarPostData($month, $year, $inman);
    } else $this->calendarEvData($month, $year, $inman);
	  echo '   });'."\n".'  })(jQuery);'."\n".'//]]>'."\n".'</script>'."\n".'</div>';
	  if ($inman == true) echo '</div>';
  }

  function calendarEvData($m, $y, $inman) {
		global $ec_MonthNames, $current_user;
    $db = new EC_DB();
    $adaptedCSS = $options['adaptedCSS'];
    $options = get_option('optionsEventsCalendar');
    // Option : Is the CSS adapted for your site ?
    $dayHasEventCSS = '';
    if(!$adaptedCSS) $dayHasEventCSS = isset($options['dayHasEventCSS']) && !empty($options['dayHasEventCSS']) ? $options['dayHasEventCSS'] : 'color:red;';
    $lastDay = date('t', mktime(0, 0, 0, $m, 1, $y));
    for($d = 1; $d <= $lastDay; $d++):
      $sqldate = date('Y-m-d', mktime(0, 0, 0, $m, $d, $y));
      $output = '<ul>'; $tdevtoutput = array();
      foreach($db->getDaysEvents($sqldate) as $e) :
        if(($e->accessLevel == 'public') || (current_user_can($e->accessLevel))) {
          $recurrStatus = isset($e->eventRecStatus) ? $e->eventRecStatus : '';
          $recStatusFlag = $recurrStatus ;
          $recProces = $e->eventRecProces;
          $recExcept = $e->eventExceptions;
          $startDate = isset($e->eventStartDate) ? $e->eventStartDate : '';
          $endTime = isset($e->eventEndTime) ? $e->eventEndTime : '';
          if ($recurrStatus && $startDate) $recurrStatus = reccurEventokToDisplay($sqldate, $startDate, $recurrStatus, $recProces, $recExcept);
          if (!$recurrStatus) {
            $title = $e->eventTitle;
            $location = isset($e->eventLocation) ? $e->eventLocation : '';
            $endDate = $e->eventEndDate;
            $startTime = isset($e->eventStartTime) ? $e->eventStartTime : '';
            if ($recStatusFlag > 0) {
              $output .= '<p style="text-align:center;font-weight:bold;background-color:black;color:white;">';
              $output .= _c('Reccur. Event','events-calendar');
              $output .= "</p>";
            }
            $output .= '<li><strong>'.$title.'</strong></li>';
            $output .= '<dd>'.$location.'</dd>';
            list($ec_startyear, $ec_startmonth, $ec_startday) = explode('-', $startDate);
            list($ec_endyear, $ec_endmonth, $ec_endday) = explode('-', $endDate);
            if (($startDate != $endDate) && ($endDate > $sqldate)) {
              $output .= '<dd>'.__('Until','events-calendar').': '.date($options['dateFormatWidget'], mktime(0, 0, 0, $ec_endmonth, $ec_endday, $ec_endyear)).'</dd>';
            }
            if (!is_null($startTime) && ($startTime!='')) {
              list($ec_starthour, $ec_startminute, $ec_startsecond) = explode(":", $startTime);
              $startTime = date($options['timeFormatWidget'], mktime($ec_starthour, $ec_startminute, $ec_startsecond, $ec_startmonth, $ec_startday, $ec_startyear));
              if (!is_null($endTime) && ($endTime!='')) {
                list($ec_endhour, $ec_endminute, $ec_endsecond) = explode(":", $endTime); $endTime = $ec_endhour.":".$ec_endminute;
                $output .= '<dd>'.$startTime.' '.__('to','events-calendar').' '.date($options['timeFormatWidget'], mktime($ec_endhour, $ec_endminute, $ec_endsecond, $ec_endmonth, $ec_endday, $ec_endyear)).'</dd>';
              } else $output .= '<dd>'.__('at','events-calendar').' '.$startTime.'</dd>';
            }
            if ($sqldate == date('Y-m-d') && $e->eventTdevt){
              $tdf = true; $tde = count($tdevtoutput); $tdevtoutput[$tde] = '<b>';
              if($startTime) $tdevtoutput[$tde] .= "$startTime ";
              if($endTime) $tdevtoutput[$tde] .= _c('to','events-calendar')." $endTime<br />";
              $tdevtoutput[$tde] .= "$title</b><br /><em>$location</em><br />$e->eventDescription";
            } else $tdf = false;
          }
        }
      endforeach;
      $output .= '</ul>';
      $clickdate = __('Click date for more details','events-calendar');
      if($output != '<ul></ul>'):
        $output .= '<span style="font-size:10px;font-weight:normal;">'.$clickdate.'</span>';
        $date_show = get_tbdate_show($d,$m,$y);
        ?>
        ecd.jq('#events-calendar-<?php echo $d;?>').attr('title', '<?php echo $output;?>');
        ecd.jq('#events-calendar-<?php echo $d;?>').attr('style', '<?php echo $dayHasEventCSS;?>');
        ecd.jq('#events-calendar-<?php echo $d;?>').mouseover(function() {ecd.jq(this).css('cursor', <?php echo ($inman == false)? "'pointer'": "'default'";?>);});
        ecd.jq('#events-calendar-<?php echo $d;?>').tooltip({track: true, delay: 0, top: -15, left: 10});
     <?php if ($inman == false) : ?>
        //ecd.jq('#events-calendar-<?php echo $d;?> a').click(function() {
          //tb_show("<?php echo $date_show; ?>", "<?php bloginfo('wpurl');?>?EC_view=day&EC_month=<?php echo $m;?>&EC_day=<?php echo $d;?>&EC_year=<?php echo $y;?>&EC_recc=<?php echo ($recStatusFlag>0)? "yes":"no";?>&TB_iframe=true&width=220&height=250", false);
        ecd.jq('#events-calendar-<?php echo $d;?> a').attr("href","<?php bloginfo('wpurl');?>?EC_view=day&EC_month=<?php echo $m;?>&EC_day=<?php echo $d;?>&EC_year=<?php echo $y;?>&EC_recc=<?php echo ($recStatusFlag>0)? "yes":"no";?>&TB_iframe=true&width=220&height=250");
        ecd.jq('#events-calendar-<?php echo $d;?> a').attr("title","<?php echo $date_show; ?>");
        //});
     <?php endif;
        if($tdf){
          $c = count($tdevtoutput);
          for($i=0;$i<$c;$i++) {
            echo '        tdevtarr[tdevtarr.length] = "'.$tdevtoutput[$i].'";
            ';
          }
        }
      endif;
    endfor;
    $this->widgetCalendarNav($m, $y, $inman);
  }

  function calendarPostData($m, $y, $inman) {
		global $ec_MonthNames, $wp_rewrite;
    $db = new EC_DB();
    // if (strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') !== false || strpos(strtolower($_SERVER['HTTP_USER_AGENT']), 'camino') !== false || strpos(strtolower($_SERVER['HTTP_USER_AGENT']), 'safari') !== false)
    //	$ak_title_separator = "\n";
    // else $ak_title_separator = ', ';
    $ak_title_separator = ', ';
    $ak_titles_for_day = array();
    $dayswithposts = $db->getDaysWithPosts($m, $y);
  	if ($dayswithposts) {
      foreach ($dayswithposts as $daywith) {
        $daywithpost[] = $daywith->post_dom;
				$post_title = apply_filters( "the_title", $daywith->post_title );
				$post_title = str_replace('"', '&quot;', wptexturize( $post_title ));
				if (empty($ak_titles_for_day['day_'.$daywith->post_dom]))
					$ak_titles_for_day['day_'.$daywith->post_dom] = '';
				if (empty($ak_titles_for_day["$daywith->post_dom"]))
					$ak_titles_for_day["$daywith->post_dom"] = '<ul><li>'.$post_title.'</li>';
				else
					$ak_titles_for_day["$daywith->post_dom"] .= '<li>'. $post_title.'</li>';
        if ($bkpd && $bkpd != $daywith->post_dom && !empty($ak_titles_for_day["$bkpd"]))
          $ak_titles_for_day["$bkpd"] .= '</ul>';
        $bkpd = $daywith->post_dom;
      }
      if (!empty($ak_titles_for_day["$daywith->post_dom"]))
        $ak_titles_for_day["$daywith->post_dom"] .= '</ul>';
    } else $daywithpost = array();
    $lastDay = date('t', mktime(0, 0, 0, $m, 1, $y));
    for($d = 1; $d <= $lastDay; $d++):
      if (in_array($d, $daywithpost) ) :
        $href = '<a id="daywithpost" href="' . get_day_link($y, $m, $d) . "?EC_action=switchMonth&EC_month=".$m."&EC_year=".$y."&EC_toggle=yes\">".$d."</a>";
        ?>
          ecd.jq('#events-calendar-<?php echo $d;?>').empty();
          ecd.jq('#events-calendar-<?php echo $d;?>').append('<?php echo $href;?>');
          ecd.jq('#events-calendar-<?php echo $d;?>').mouseover(function() {ecd.jq(this).css('cursor', 'pointer');});
          ecd.jq('#events-calendar-<?php echo $d;?>').attr('title', '<?php echo $ak_titles_for_day[$d];?>');
          ecd.jq('#events-calendar-<?php echo $d;?>').tooltip({track: true, delay: 0, top: -15, left: 10});
        <?php
        if($d==date('d')){
            echo '        tdevtarr[0] = "<b>'._c('Post(s) of the day:','events-calendar').'</b><br/>'.$ak_titles_for_day[$d].'";
';
        }
      endif;
    endfor;
    $this->widgetCalendarNav($m, $y, $inman);
  }

  function widgetCalendarNav($m, $y, $inman) {
    global $ec_MonthNames;
    if(isset($_GET['EC_toggle']) && $_GET['EC_toggle'] == 'yes') $toggle_post = 'yes'; else $toggle_post = 'no';
    // echo "alert('toggle_post=".$toggle_post."');\n";
    $img_rwmonth = EVENTSCALENDARIMAGESURL.'/rwmonth.gif';
    $img_ffmonth = EVENTSCALENDARIMAGESURL.'/ffmonth.gif';
    $img_aloader = EVENTSCALENDARIMAGESURL.'/ajax-loader.gif';
    $img_getyear = EVENTSCALENDARIMAGESURL.'/getyear.png';
    $img_chkmonth = EVENTSCALENDARIMAGESURL.'/chkmonth.png';
    $img_chkyear = EVENTSCALENDARIMAGESURL.'/chkyear.png';
    $img_today = EVENTSCALENDARIMAGESURL.'/today.png';
    $img_tdevt = EVENTSCALENDARIMAGESURL.'/tdevt.png';
    $img_tdevfg = EVENTSCALENDARIMAGESURL.'/tdevfg.gif';
    $img_tdevfd = EVENTSCALENDARIMAGESURL.'/tdevfd.gif';
    $date_show = get_tbdate_show(0, get_incrMonth($m-1),($m==1) ? ($y-1) : 0);
    $att_rwmonth = _c('Go to','events-calendar').' <b>'.$date_show.'</b>';
    $date_show = get_tbdate_show(0, get_incrMonth($m+1),($m==12) ? ($y+1) : 0);
    $att_ffmonth = _c('Go to','events-calendar').' <b>'.$date_show.'</b>';
    // define the vertical and horizontal lists
    $curr_year = date("Y");
    // Vertical list
    $selVMonthList = "<span id=\"spanVMonthList\"><img src=\"$img_chkmonth\"/>&nbsp;<b>"._c('Month','events-calendar')."</b></span><ul>";
    $selVYearList = "<span id=\"spanVYearList\"><img src=\"$img_chkyear\"/>&nbsp;<b>"._c('Year','events-calendar')."</b></span><ul>";
    for ($i=1;$i<13;$i++ ) {
    	$selVMonthList .= "<li id=\"itemVMonth-$i\">$ec_MonthNames[$i]</li>";
    }
    $selVMonthList .= '</ul>';
    $selVYearList .= "<li id=\"itemVYear-get\"><input autocomplete=\"OFF\" type=\"text\" name=\"EC_selyear_get\" id=\"EC_selyear_get\" value=\"20\"/>&nbsp;<img src=\"$img_getyear\" style=\"cursor:pointer;\" id=\"itemYear-click\"/></li>";
    for ($i=($curr_year-6);$i<($curr_year+5);$i++) {
      $selVYearList .= "<li id=\"itemVYear-$i\" style=\"display:block;\">$i</li>";
    }
    $selVYearList .= '</ul>';
    // Horizontal lists
    $selHMonthList = "<span id=\"spanHMonthList\"><img src=\"$img_chkmonth\"/>&nbsp;<b>"._c('Month','events-calendar')."</b></span><ul>";
    $selHYearList = "<span id=\"spanHYearList\"><img src=\"$img_chkyear\"/>&nbsp;<b>"._c('Year','events-calendar')."</b></span><ul>";
    $j = 1; $selHMonthList .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" align=\"center\">";
    for ($i=1;$i<13;$i++ ) {
      if ($j == 1) $selHMonthList .="<tr>";
    	$selHMonthList .= "<td id=\"itemMonth-$i\" style=\"width:100px;\">$ec_MonthNames[$i]</td>";
    	if ($j == 6) { $selHMonthList .= "</tr>"; $j = 0; }
    	$j++;
    }
    $selHMonthList .= "</table></ul>";
    $selHYearList .= "<table border=\"0\" cellspacing=\"0\" cellpadding=\"5\" align=\"center\">";
    $selHYearList .= "<tr><td id=\"itemYear-get\"><input autocomplete=\"OFF\" type=\"text\" name=\"EC_selyear_get\" id=\"EC_selyear_get\" value=\"20\" style=\"width:40px;\"/>&nbsp;<img src=\"$img_getyear\" style=\"cursor:pointer;\" id=\"itemYear-click\"/></td>";
    $j = 2;
    for ($i=($curr_year-6);$i<($curr_year+5);$i++ ) {
      if ($j == 1) $selHYearList .="<tr>";
      $selHYearList .= "<td id=\"itemYear-$i\" style=\"width:80px;\">$i</td>";
      if ($j == 6) { $selHYearList .= "</tr>"; $j = 0; }
      $j++;
    }
    $selHYearList .= "</table></ul>";
    if ($toggle_post == 'no') {
      echo '    var togglepost = false;'."\n";
    } else {
      echo 'var togglepost = true;'."\n";
      echo "    ecd.jq('#wp-calendar th').css('background-color','#2583ad');\n";
    }
      ?>
      function Go_To_Month(mtarget,ytarget,toggle) {
        ecd.jq('#EC_loadingPane').empty();
        ecd.jq('#EC_loadingPane').append('<img src="<?php echo $img_aloader;?>" style="width:16px;" />');
        if (toggle == true) {
          togglepass = 'yes';
        } else {
          if (toggle == false) togglepass = 'no';
        }
        ecd.jq.get("<?php bloginfo('wpurl');?>/index.php?",
        {EC_action: "switchMonth", EC_month: mtarget, EC_year: ytarget, EC_toggle: togglepass},
        function(data) {
        <?php if ($inman == false) : ?>
          ecd.jq('#evcalendar_wrap').empty();
          ecd.jq('#evcalendar_wrap').append(ecd.jq(data).html());
        <?php else: ?>
          ecd.jq('#ecform_wcalendar').empty();
          ecd.jq('#ecform_wcalendar').append(ecd.jq(data).html());
        <?php endif; ?>
        });
      }
      if(tdevtarr.length>0) {
        ecd.jq('#msg-tdevt').empty(); tdi = 0;
        ecd.jq('#msg-tdevt').append(tdevtarr[0]);
      }
      if(tdevtarr.length>1) {
        ecd.jq('#tdevtimg-fg').attr({src:"<?php echo $img_tdevfg;?>", title: "<?php _e('previous','events-calendar');?>"});
        ecd.jq('#tdevtimg-fd').attr({src:"<?php echo $img_tdevfd;?>", title: "<?php _e('next','events-calendar');?>"});
      }
      ecd.jq('#tdevtimg-fg').click(function(e) {
        e.stopPropagation();
        if(tdi==0) tdi=tdevtarr.length-1; else tdi--;
        ecd.jq('#msg-tdevt').empty(); ecd.jq('#msg-tdevt').append(tdevtarr[tdi]);
      });
      ecd.jq('#tdevtimg-fd').click(function(e) {
        e.stopPropagation();
        if(tdi==(tdevtarr.length-1)) tdi=0; else tdi++;
        ecd.jq('#msg-tdevt').empty(); ecd.jq('#msg-tdevt').append(tdevtarr[tdi]);
      });
      ecd.jq('#buttopt-4, #tdevt, #msg-tdevt').click(function(e) {
        e.stopPropagation();
        if(document.getElementById('tdevt').style.display == 'none') ecd.jq("#tdevt").css("display","block"); else ecd.jq("#tdevt").css("display","none");
      });
      jQuery.fn.extend({
         findAbsPos : function() {
             obj = $(this).get(0);
             var curleft = obj.offsetLeft || 0;
             var curtop = obj.offsetTop || 0;
             while (obj = obj.offsetParent) {
                      curleft += obj.offsetLeft
                      curtop += obj.offsetTop
             }
             return {posleft:curleft,postop:curtop};
         }
      });
      ecd.jq('.buttoptcl').mouseover(function() {
        var selbutt = $(this).attr("id");
          switch(selbutt) {
            case "buttopt-1":
              if (togglepost == false) {
                ecd.jq("#buttopt-1").append('<?php _e('Posts','events-calendar');?>'); break;
              } else {
                ecd.jq("#buttopt-1").append('<?php _e('Events','events-calendar');?>'); break;
              }
            case "buttopt-2":
              ecd.jq("#buttopt-2").append('<?php _e('Filter','events-calendar');?>'); break;
            case "buttopt-3":
              ecd.jq("#buttopt-3").append('<?php _e('Search','events-calendar');?>'); break;
            case "buttopt-4":
              ecd.jq("#buttopt-4").append('<?php _e('Today','events-calendar');?>'); break;
            case "buttopt-5":
              ecd.jq("#buttopt-5").append('<?php _e('Add','events-calendar');?>'); break;
          }
      });
      ecd.jq('.buttoptcl').mouseout(function() {
          ecd.jq(this).empty();
      });
      ecd.jq('#EC_SelectMonth').append('<?php echo $selHMonthList;?>');
      var Hlist_h = ecd.jq("#EC_SelectMonth ul").height();
      var Hlist_w = ecd.jq("#EC_SelectMonth ul").width();
      ecd.jq('#EC_SelectMonth').empty();
      ecd.jq('#EC_SelectMonth').append('<?php echo $selVMonthList;?>');
      var Vlist_h = ecd.jq("#EC_SelectMonth ul").height();
      var Vlist_w = ecd.jq("#EC_SelectMonth ul").width();
      ecd.jq('#EC_SelectMonth').empty();
      var eSM_h = ecd.jq('#EC_SelectMonth').height();
      var eSM_w = ecd.jq('#EC_SelectMonth').width();
      eSM = ecd.jq('#EC_SelectMonth').findAbsPos();
      eSY = ecd.jq('#EC_SelectYear').findAbsPos();
      var Body_h = ecd.jq('body').height();
      var Body_w = ecd.jq('body').width();
      if (Vlist_h <= (Body_h - (eSM.postop + eSM_h))) {
        if(ecd.jq.browser.opera) {
          ecd.jq('#EC_SelectMonth').append('<?php echo $selHMonthList;?>');
          ecd.jq('#EC_SelectYear').append('<?php echo $selHYearList;?>');
        } else {
          ecd.jq('#EC_SelectMonth').append('<?php echo $selVMonthList;?>');
          ecd.jq('#EC_SelectYear').append('<?php echo $selVYearList;?>');
          if(ecd.jq.browser.msie) {
            var vboffset = ecd.jq("#wp-calendar .pad").height();
            var hboffset = -((ecd.jq("#EC_SelectMonth span").width()/2)+(ecd.jq("#EC_SelectMonth ul").width()/2));
          }
        }
      } else {
        if (Hlist_w <= (Body_w - (eSM.posleft + eSM_w))) {
          ecd.jq('#EC_SelectMonth').append('<?php echo $selHMonthList;?>');
          ecd.jq('#EC_SelectYear').append('<?php echo $selHYearList;?>');
        } else {
          ecd.jq('#EC_SelectMonth').append('<?php echo $selHMonthList;?>');
          ecd.jq('#EC_SelectYear').append('<?php echo $selHYearList;?>');
        }
      }
      ecd.jq("#EC_SelectMonth ul").css({marginTop:vboffset+"px"});
      ecd.jq("#EC_SelectMonth ul").css({marginLeft:hboffset+"px"});
      ecd.jq("#EC_SelectYear ul").css({marginTop:vboffset+"px"});
      ecd.jq("#EC_SelectYear ul").css({marginLeft:hboffset+"px"});
      <?php if ($inman == true) : ?>
        ecd.jq("#EC_SelectMonth ul").css({marginTop:"2px"});
        ecd.jq("#EC_SelectMonth ul").css({marginLeft:"5px"});
        ecd.jq("#EC_SelectYear ul").css({marginTop:"2px"});
        ecd.jq("#EC_SelectYear ul").css({marginLeft:"5px"});
      <?php endif; ?>
      ecd.jq('#EC_loadingPane').append('<img src="<?php echo $img_today;?>"/>');
      ecd.jq('#EC_rwMonth').append('<img src="<?php echo $img_rwmonth;?>"/>');
      ecd.jq('#EC_rwMonth').attr('title', '<?php echo $att_rwmonth;?>');
      ecd.jq('#EC_rwMonth').tooltip({track: true, delay: 0, fade: 250, extraClass: "gotomonth"});
      ecd.jq('#EC_ffMonth').append('<img src="<?php echo $img_ffmonth;?>"/>');
      ecd.jq('#EC_ffMonth').attr('title', '<?php echo $att_ffmonth;?>');
      ecd.jq('#EC_ffMonth').tooltip({track: true, delay: 0, fade: 250, extraClass: "gotomonth"});
      ecd.jq('#EC_loadingPane').attr('title', '<?php _e("Go Today","events-calendar");?>');
      ecd.jq('#EC_loadingPane').tooltip({track: true, delay: 0, fade: 250, extraClass: "gotomonth"});
      ecd.jq('#EC_SelectMonth').attr('title', '<?php _e("Select a month","events-calendar");?>');
      ecd.jq('#EC_SelectMonth').tooltip({track: true, delay: 0, top: -45, fade: 250, extraClass: "gotomonth"});
      ecd.jq('#EC_SelectYear').attr('title', '<?php _e("Select a year","events-calendar");?>');
      ecd.jq('#EC_SelectYear').tooltip({track: true, delay: 0, top: -45, fade: 250, extraClass: "gotomonth"});
      ecd.jq('#EC_loadingPane').click(function(){
        ectoday = new Date();
        Go_To_Month((ectoday.getMonth()+1),ectoday.getFullYear(), togglepost);
      });
      ecd.jq('#buttopt-1').click(function(){
        if (togglepost == true ) togglepost = false; else togglepost = true;
        Go_To_Month( <?php echo $m;?>, <?php echo $y;?>, togglepost);
      });
      ecd.jq("#EC_SelectMonth span").click(function(e){
    	  ecd.jq("#EC_SelectMonth ul").slideToggle("normal");
    	  ecd.jq("#EC_SelectYear ul").fadeOut("normal");
        return false;
    	});
    	ecd.jq("#EC_SelectMonth li,#EC_SelectMonth td").click(function(){
        var selmonth = $(this).attr("id").split('-');
        ecd.jq("#EC_SelectMonth ul").fadeOut("normal");
        Go_To_Month(selmonth[1], <?php echo $y;?>, togglepost);
    	});
    	ecd.jq("#EC_SelectYear span").click(function(){
    	  ecd.jq("#EC_SelectYear ul").slideToggle("normal");
    	  ecd.jq("#EC_SelectMonth ul").fadeOut("normal");
    	  return false;
    	});
    	ecd.jq("#EC_SelectYear ul li,#EC_SelectYear td").click(function(){
        var selyear = $(this).attr("id").split('-');
        if (selyear[1]=='get') return false;
        ecd.jq("#EC_SelectYear ul").fadeOut("normal");
        Go_To_Month(<?php echo $m;?>, selyear[1], togglepost);
    	});
    	ecd.jq('body').click(function() {
    	 ecd.jq("#EC_SelectMonth ul").fadeOut("normal");
    	 ecd.jq("#EC_SelectYear ul").fadeOut("normal");
    	 //if(document.getElementById('tdevt').style.display == 'block') ecd.jq("#tdevt").css("display","none");
    	});
      ecd.jq('#EC_rwMonth').click(function() {
        Go_To_Month(<?php echo get_incrMonth($m-1);?>, <?php echo ($m==1) ? ($y-1) : $y;?>, togglepost);
      });
      ecd.jq('#EC_ffMonth').click(function() {
        Go_To_Month(<?php echo get_incrMonth($m+1);?>, <?php echo ($m==12) ? ($y+1) : $y;?>, togglepost);
      });
      ecd.jq('#itemYear-click').click(function() {
        var recup = ecd.jq("#EC_selyear_get").val();
        if (recup > '1969') {
          ecd.jq("#EC_selyear_get").val('');
          Go_To_Month(<?php echo $m;?>, recup, togglepost);
        }
      });
      ecd.jq("#EC_selyear_get").keypress(function(e) {
        var code = (e.keyCode ? e.keyCode : e.which);
        if (code == 13) ecd.jq("#itemYear-click").trigger("click");
        if (code == 0) ecd.jq("body").trigger("click");
      });
      <?php
  }
}
endif;
?>